//入力
//======================================================================================

Game.prototype.SHOOT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.J] || bbw[keys.Ctrl] || bbw[keys.L]  || bbw[keys.PadA]  || bbw[keys.PadY]);
}
Game.prototype.SHOOTSUB = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.I] || bbw[keys.Space] || bbw[keys.Shift]  || bbw[keys.PadB]  || bbw[keys.PadX]);
}
Game.prototype.UP = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.W] || bbw[keys.Up] || bbw[keys.PadUp]);
}
Game.prototype.DOWN = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.S] || bbw[keys.Dw] || bbw[keys.PadDw]);
}
Game.prototype.LEFT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.A] || bbw[keys.Le] || bbw[keys.PadLe]);
}
Game.prototype.RIGHT = function(fat) {
	const bbw = fat ? keyPulls : keyPushs;
	return (bbw[keys.D] || bbw[keys.Ri] || bbw[keys.PadRi]);
}

//キーボードプッシュ
document.addEventListener("keydown", keyDownFunc);
function keyDownFunc(e) {
		keyPulls[e.keyCode] = true;
		keyPushs[e.keyCode] = true;
}

//キーボードリリース
document.addEventListener("keyup", keyUpFunc);
function keyUpFunc(e) {
	keyPulls[e.keyCode] = false;
}


//ゲームパッド
function GamePadFunc(){
	var gamepadList = navigator.getGamepads();
	for(var i=0; i<gamepadList.length; i++){
		var gamepad = gamepadList[i];
		if (gamepad) {
			document.getElementById("Pad").textContent = gamepad.id;

			for(var i=0; i<gamepad.buttons.length; i++){
				if (!keyPulls[i+5000] && gamepad.buttons[i].pressed) keyPushs[i+5000] = gamepad.buttons[i].pressed;
				keyPulls[i+5000] = gamepad.buttons[i].pressed;
			}
		}
	}
}

//======================================================================================
//======================================================================================
//======================================================================================