//通常敵プッシュ
Game.prototype.SpritePush = function(x,y,hx,hy,data) {
	const i = game.NullFined(Sprites);
	Sprites[i]=data;
	//そして基本的情報を挿入
	game.SpriteKiso(Sprites[i],x,y,hx,hy,KeyIndexs);
	KeyIndexs++;
}
//敵の基本情報
Game.prototype.SpriteKiso = function(data,x,y,hx,hy,key) {
	data.Key = key;
	data.Live = true;				//生存確認
	data.x = x,	data.y = y;			//座標
	data.hx = hx,	data.hy = hy;	//慣性
	data.Debu = 0;					//脂肪
	data.Fat = 0;					//デブ度の段階
	data.Dame = false;				//フレームのダメージ
	data.DameTimer = 0;				//ダメージを受けてからの経過時間
	data.Timer = 0;					//タイマー
	data.DrawSize = 0;
	data.PoyoTimer = 0;
}

//テストスプライト
//==============================================================================================
Game.prototype.TestMan = function() {
	this.Size = [30,30];
}
Game.prototype.TestMan.prototype.Func = function(index) {
	//描画
	game.DrawKage(ctxA,GFXs["Test"],this.x,this.y,this.DrawSize,this.DrawSize,game.Dame(this.Dame),false,false);

	game.GamenOut(this);	//画面外消失

	if (this.Dame != false) {
		if (this.Debu > 100) {
			this.Live = false;
			//game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		} else {
		}
	}
			this.x -= 1;
}

//バイオコーン
//==============================================================================================
Game.prototype.Toumorokosi = function(s) {
	this.Roll = Math.random()*PI,	this.RollPls = (Math.random()-0.5)/12;
	this.S = s;
	this.Size = [60*s,60*s];
}
Game.prototype.Toumorokosi.prototype.Func = function(index) {

	if (game.PlayerHit(this)) {
		const r = game.PlayerRadis(this.x,this.y);
		this.hx = r[0]*-10;
		this.hy = r[1]*-10;
		//this.Dame = true;
		//this.Debu += 1;
	}
	game.Move(this);		//慣性移動
	game.MoveLose(this,0.95);	//摩擦
	game.GamenOut(this);	//画面外消失

	this.x -= 6*(2-this.S);
	this.Roll += this.RollPls;

	//描画
	game.DrawKage(ctxA,GFXs["Tama14"],	this.x,this.y,	this.S,this.S,	game.Dame2(this.Dame),this.Roll		,false);

	if (this.Dame != false) {
		if (this.Debu > 30) {
			this.Live = false;
			game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
			for (let i=0 ; i<12 ; i++) {
				game.SFXPush(this.x, this.y,	game.Random(8),game.Random(8)-5,	false,	new game.Himatu("Sfx60"));
			}
			game.ScoreMan(30);		//スコア
			game.PlaySE("Boom00");		//音
		} else {
			game.SFXPush(this.x, this.y,	game.Random(10)+5,game.Random(10)-10,	false,	new game.Himatu("Sfx60"));
			this.hx = 2;
			this.RollPls = this.RollPls*1.2;
		}
	}

}

/*
コピペ用
//==============================================================================================
	game.Move(this);		//慣性移動
	game.GamenOut(this);	//画面外消失
	//描画
	game.DrawKage(ctxA,GFXs["Test"],	this.x,this.y,	this.DrawSize,this.DrawSize,		game.Dame(this.Dame),false,	false);
*/

//ねずみさん
//==============================================================================================
Game.prototype.Nezumi = function(a, gx, gy) {
	this.Size = [40,100];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Nezumi.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 330) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.SFXPush("Ban",this.x, this.y, 0,0, 0,0, null);

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			//this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>8) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki00"];

		//健康的
		if (this.Debu == 0) {
			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer++;
				if (this.AttackTimer<150) {
					img = GFXs["Teki01"];
					//発射
					if (game.LiveShoot() && (this.AttackTimer == 50 || this.AttackTimer == 80 || this.AttackTimer == 110)) {
						this.DrawSize -= 0.2;
						const r = game.PlayerRadis(this.x,this.y);
						game.TekiTamaPush(this.x-50, this.y,	r[0]*7*Rank,r[1]*7*Rank, r[2],		new game.TizuShoot());
						this.hx -= r[0]*3;
						this.hy -= r[1]*3;
						game.PlaySE("Shoot01");		//音
					}
				}
			}
		//肥満気味
		} else {
			this.AttackTimer = 0;

			if (this.Debu<10) {
				this.Size = [40,100];
				game.FatSE(this, 0, 0);	//デブ音
			} else if (this.Debu<100) {
				img = GFXs["Teki02"];
				this.Size = [50,100];
				game.FatSE(this, 1, 0);	//デブ音
			} else if (this.Debu<200) {
				img = GFXs["Teki03"];
				this.Size = [80,100];
				game.FatSE(this, 2, 0);	//デブ音
			} else {
				game.AseFunc(this.x+60, this.y-100);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				//game.ScoreMan(1);		//スコア
				img = GFXs["Teki04"];
				this.Size = [100,100];
				game.FatSE(this, 3, 0);	//デブ音
			}

		}

		//行動
		switch (this.Action) {
			//右へ帰る
			case 1:
			case 2:
				const tt = this.Action==1 ? 600 : 800;
				if (t<tt) {
					if ( t==50 || t==300 || t==600) this.AttackTimer = 1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += (t-tt)/2;
				}
				this.hx += Math.cos(t/32)*0.08;
				this.hy += Math.cos(t/16)*0.08;
				this.x = (this.x*99 + this.gx)/100;
				this.y = (this.y*99 + this.gy)/100;
				break;

			//左へ
			case 5:
				if (t<300) {
					if ( t==10 || t==110) this.AttackTimer = 1;
					if (this.Debu<10) this.gx -= 3;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += 10;
				}
				game.GoMove2(this, this.gx, this.gy, 0.03);		//座標指定
				this.hy += Math.cos(t/12)*0.1;
				break;
		}


		game.Move(this);				//慣性移動
		game.MoveLose(this,0.98);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,330,0.3),this.DrawSize, game.Dame(this.Dame),false,	false);
	}

}

//うさぎさん
//==============================================================================================
Game.prototype.Usagi = function(a,gx,gy) {
	this.Size = [40,100];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Usagi.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 330) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.SFXPush("Ban",this.x, this.y, 0,0, 0,0, null);

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki20"];

		//健康的
		if (this.Debu == 0) {
			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer++;
				if (this.AttackTimer<150) {
					img = GFXs["Teki21"];
					//発射
					if (game.LiveShoot() && (this.AttackTimer == 50 || this.AttackTimer == 70 || this.AttackTimer == 90)) {
						this.DrawSize -= 0.2;
						game.TekiTamaPush(this.x-50, this.y,	-10*Rank,0, PI,		new game.NInzinShoot());
						game.PlaySE("Shoot01");		//音
					}
				}
			}

		//肥満気味
		} else {
			this.AttackTimer = 0;

			if (this.Debu<10) {
				this.Size = [40,100];
				game.FatSE(this, 0, 0);	//デブ音
			} else if (this.Debu<100) {
				img = GFXs["Teki22"];
				this.Size = [50,100];
				game.FatSE(this, 1, 0);	//デブ音
			} else if (this.Debu<200) {
				img = GFXs["Teki23"];
				this.Size = [60,100];
				game.FatSE(this, 2, 0);	//デブ音
			} else {
				game.AseFunc(this.x+60, this.y-100);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				//game.ScoreMan(1);		//スコア
				img = GFXs["Teki24"];
				this.Size = [80,120];
				game.FatSE(this, 3, 0);	//デブ音
			}
		}

		//行動
		switch (this.Action) {
			//右へ帰る
			case 1:
			case 2:
				const tt = this.Action==1 ? 600 : 800;
				if (t<tt) {
					if (t%200==0) this.AttackTimer = 1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gx += (t-tt)/2;
				}
				//this.hx += Math.cos(t/32)*0.08;
				this.x = (this.x*99 + this.gx)/100;
				this.y = (this.y*99 + this.gy)/100;
				break;
		}


		game.Move(this);			//慣性移動
		game.MoveLose(this,0.98);		//摩擦


		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,330,0.3),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//はちさん
//==============================================================================================
Game.prototype.Hati = function(a, gx=0, gy=0) {
	this.Size = [40,70];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Hati.prototype.Func = function() {
	const t = this.Timer;
	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし
	//しぼう
	if (this.Debu > 90) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,10);
		game.ScoreMan(50);		//スコア
		game.PlaySE("Boom00");		//音

		game.NikuFunc(this.x, this.y, 3);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki10"];

		//健康的
		if (this.Debu == 0) {
				img = Loop4 ? GFXs["Teki10"] : GFXs["Teki11"];
				this.Size = [40,70];

				//発射
				if (t%10==0 && t%50<30) {
					this.DrawSize -= 0.1;
					game.TekiTamaPush(this.x-50, this.y+10,	-15*Rank,0, PI,		new game.HariShoot());
				}
				game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			//game.ScoreMan(1);		//スコア
			//game.NikusFunc(this.x, this.y);	//肉ばら撒き
			this.Size = [60,70];
			this.hx *= 0.99;
			img = GFXs["Teki12"];
			game.AseFunc(this.x+60, this.y-100);
			game.FatSE(this, 1, 0);	//デブ音
		}

		//行動
		switch (this.Action) {
			//
			case 0:
				if (t>300) {
					game.GamenOut(this);	//画面外消失
				}
				this.hx = Math.max(-3, this.hx-0.05);
				break;

			case 5:
				if (t>300) game.GamenOut(this);	//画面外消失
				game.GoMove2(this, this.gx, this.gy, 0.03);		//座標指定
				if (this.Debu<10) this.gx -= 3;
				break;

		}

		this.hy += Math.cos(t/12)*0.1;


		game.Move(this);		//慣性移動


		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,90,0.3),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//キツネさん
//==============================================================================================
Game.prototype.Kitune = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Kitune.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 600) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//game.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki30"];
		let plssize = 0;

		//健康的
		if (this.Debu < 150) {
			this.Size = [40,120];
			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer--;
				img = GFXs["Teki31"];
				//発射
				if (game.LiveShoot() && (this.AttackTimer == 50 || this.AttackTimer == 80)) {
					this.DrawSize -= 0.2;
					const radi = game.PlayerRadi(this.x,this.y);
					let speed = 5;

					let rr = 0.8 - Rank*0.2;
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,			new game.OinariShoot());
					rr *= 2;
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.OinariShoot());
					game.TekiTamaPush(this.x,this.y,	Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.OinariShoot());

					this.hx -= Math.cos(radi)*2;
					this.hy -= Math.sin(radi)*2;
					game.PlaySE("Shoot01");		//音
				}
			}
			game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			this.AttackTimer = 0;
			if (this.Debu<250) {
				img = GFXs["Teki32"];
				this.Size = [60,120];
				game.FatSE(this, 1, 0);	//デブ音
			} else if (this.Debu<400) {
				img = GFXs["Teki33"];
				this.Size = [90,130];
				game.FatSE(this, 2, 0);	//デブ音
			} else {
				game.AseFunc(this.x+60, this.y-130);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki34"];
				this.Size = [110,140];
				game.FatSE(this, 3, 0);	//デブ音
			}

		}

		//行動
		switch (this.Action) {

			case 1:	//上へ帰る
			case 2:	//下へ帰る

				if (t<400) {
					if (this.Debu<1 && this.AttackTimer==0) {
						if ((t>50 && t<150) || (t>300 && t<400))  {
							this.AttackTimer = 100;
						}
					}
					this.gy += (this.Action==1 ? -1 : 1)*1;

					this.hx += Math.cos(t/32)*0.08;
					this.hy += Math.cos(t/16)*0.08;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gy += (this.Action==1 ? -3 : 3);
				}
				break;
		}

		//this.hx += Math.cos(t/32)*0.08;
		//this.hy += Math.cos(t/16)*0.08;
		this.x = ((this.x - this.gx) * 0.99) + this.gx;
		this.y = ((this.y - this.gy) * 0.95) + this.gy;

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.98);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize+plssize + game.PuyoMan(this,600,0.2),this.DrawSize+plssize,	game.Dame(this.Dame),false,	false);
	}

}

//ラムさん
//==============================================================================================
Game.prototype.Ramu = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.gx = gx,	this.gy = gy;
	this.ShootRadi = 0;
}
Game.prototype.Ramu.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 700) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(100);		//スコア
		game.PlaySE("Boom00");		//音

		//.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki40"];
		let plssize = 0;

		//健康的
		if (this.Debu < 150) {
			this.Size = [40,140];
			//攻撃タイマーがアクティブか
			if (this.AttackTimer>0) {
				this.AttackTimer--;
				img = GFXs["Teki41"];
				if (this.AttackTimer==140) this.ShootRadi = game.PlayerRadi(this.x,this.y);
				//発射
				if (game.LiveShoot() && (this.AttackTimer > 20 && this.AttackTimer < 140 && this.AttackTimer%40 == 0)) {
					this.DrawSize -= 0.2;
					const radi = this.ShootRadi;
					let speed = 5 * Rank;
					const rr = 0.04;

					game.TekiTamaPush(this.x + Math.cos(radi+HalfPI)*20,this.y + Math.sin(radi+HalfPI)*20,
						Math.cos(radi+rr)*speed,Math.sin(radi+rr)*speed, radi+rr,		new game.FuramsuShoot());
					game.TekiTamaPush(this.x + Math.cos(radi-HalfPI)*20,this.y + Math.sin(radi-HalfPI)*20,
						Math.cos(radi-rr)*speed,Math.sin(radi-rr)*speed, radi-rr,		new game.FuramsuShoot());

					this.hx -= Math.cos(radi)*4;
					this.hy -= Math.sin(radi)*4;
					game.PlaySE("Shoot01");		//音
				}
			}
			game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			this.AttackTimer = 0;
			if (this.Debu<300) {
				img = GFXs["Teki42"];
				this.Size = [60,150];
				game.FatSE(this, 1, 0);	//デブ音
			} else if (this.Debu<450) {
				img = GFXs["Teki43"];
				this.Size = [90,160];
				game.FatSE(this, 2, 0);	//デブ音
			} else {
				game.AseFunc(this.x+90, this.y-130);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki44"];
				this.Size = [110,170];
				game.FatSE(this, 3, 0);	//デブ音
			}

		}

		//行動
		switch (this.Action) {

			case 1:	//上へ帰る
			case 2:	//下へ帰る

				if (t<400) {
					if (this.Debu<1 && this.AttackTimer==0) {
						if ((t>50 && t<150) || (t>300 && t<400))  {
							this.AttackTimer = 150;
							//this.ShootRadi = game.PlayerRadi(this.x,this.y);
						}
					}
					this.gx -= 1;

					//this.hx += Math.cos(t/32)*0.08;
					this.hy += Math.cos(t/16)*0.1;
				} else {
					game.GamenOut(this);	//画面外消失
					this.gy += (this.x < 0 ? -3 : 3);
				}
				break;
		}

		//this.hx += Math.cos(t/32)*0.08;
		//this.hy += Math.cos(t/16)*0.08;
		this.x = ((this.x - this.gx) * 0.97) + this.gx;
		this.y = ((this.y - this.gy) * 0.97) + this.gy;

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize+plssize + game.PuyoMan(this,700,0.2),this.DrawSize+plssize,	game.Dame(this.Dame),false,	false);
	}

}

//リスさん
//==============================================================================================
Game.prototype.Risu = function(a) {
	this.Size = [40,70];
	this.Action = a;
	this.AttackTimer = 0;
}
Game.prototype.Risu.prototype.Func = function() {
	const t = this.Timer;
	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 50) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
		//game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,10);
		game.ScoreMan(50);		//スコア
		game.PlaySE("Boom00");		//音

		//打ち返し
		const radi = game.PlayerRadi(this.x,this.y);
		game.TekiTamaPush(this.x,this.y,
			Math.cos(radi),Math.sin(radi), radi,		new game.NattuShoot());
		//game.PlaySE("Shoot01");		//音

		game.NikuFunc(this.x, this.y, 2);	//ニク撒き

	//生存中
	} else {

		let img = GFXs["Teki50"];

		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.1;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>60) this.Debu = Math.max(0,this.Debu-=1);
		}

		//健康的
		if (this.Debu == 0) {
				this.Size = [40,70];
				game.FatSE(this, 0, 0);	//デブ音
		//肥満気味
		} else {
			//game.ScoreMan(1);		//スコア
			//game.NikusFunc(this.x, this.y);	//肉ばら撒き
			this.Size = [60,70];

			this.hx *= 0.99;
			img = GFXs["Teki51"];
			game.AseFunc(this.x+60, this.y-100);
			game.FatSE(this, 1, 0);	//デブ音
		}

		//行動
		switch (this.Action) {
			//自機の方へ向かって右へ帰る
			case 0:
				if (t==1) this.hy = (Player.y - this.y)/100;
				if (t>150) {
					game.GamenOut(this);	//画面外消失
					this.hx += 0.2;
				}
				break;

			//右へ帰る
			case 1:
				if (t>150) {
					game.GamenOut(this);	//画面外消失
					this.hx += 0.2;
				}
				break;
		}

		this.hy += Math.cos(t/12)*0.1;


		game.Move(this);				//慣性移動
		game.MoveLose(this,0.99);		//摩擦

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,50,0.2),this.DrawSize,	game.Dame(this.Dame),false,	false);
	}

}

//ぶたさん
//==============================================================================================
Game.prototype.Buta = function(a, gx, gy) {
	this.Size = [40,120];
	this.Action = a;
	this.AttackTimer = 0;
	this.AnimeR = 0;
	this.ShootR = Math.random()+TwoPI;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Buta.prototype.Func = function() {
	game.Hayamawasi(this);				//早回し防止

	const t = this.Timer;

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//しぼう
	if (this.Debu > 450) {
		this.Live = false;

		game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());

		game.FatBallsFunc(this.x,this.y,12);
		game.FatSlagsFunc(this.x,this.y,30);

		game.ScoreMan(200);		//スコア
		game.PlaySE("Boom00");		//音

		//.NikuFunc(this.x, this.y, 5);	//ニク撒き

	//生存中
	} else {
		//ダメージ
		if (this.Dame) {
			this.DrawSize -= 0.05;
			this.PoyoTimer = 1;
		} else {
			if (this.DameTimer>20) this.Debu = Math.max(0,this.Debu-=2);
		}

		let img = GFXs["Teki60"];

		this.AttackTimer++;
		this.AnimeR *= 0.9;

		//健康的
		if (this.Debu < 100) {
			this.Size = [40,120];
			game.FatSE(this, 0, 0);	//デブ音

			const at = this.AttackTimer%100;

			if (game.LiveShoot() && at == 80) {
				this.DrawSize -= 0.2;

					/*for (let i=0 ; i<4 ; i++) {
						for (let j=0 ; j<3 ; j++) {
							const speed = 6*Rank - j;
							const radi = this.ShootR + i*HalfPI;
							game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
								Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.TizuShoot());

						}
					}
					this.ShootR += 0.2;*/
					

				/*const rad = PI-0.3;
				for (let i=0 ; i<4*Rank ; i++) {
					const speed = 6*Rank - i*0.5;
					let radi = rad;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());

					radi = TwoPI-rad;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());

				}*/

				for (let i=2+2*Rank ; i>0 ; i--) {
					const radi = game.PlayerRadi(this.x,this.y);// + (Math.random()-0.5);
					const speed = 10 - i;
					game.TekiTamaPush(this.x + Math.cos(radi)*50,this.y + Math.sin(radi)*50,
						Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.HamuShoot());
				}

				game.PlaySE("Shoot01");		//音
				this.AnimeR = HalfPI;
				this.hx += 12;
			}
			if (at>50) {
				img = GFXs["Teki64"];
			}

		//肥満気味
		} else {

			this.AttackTimer = 0;
			this.AnimeR = 0;

			if (this.Debu<200) {
				img = GFXs["Teki61"];
				this.Size = [60,150];
				game.FatSE(this, 1, 0);	//デブ音

			} else if (this.Debu<300) {
				img = GFXs["Teki62"];
				this.Size = [90,160];
				game.FatSE(this, 2, 0);	//デブ音

			} else {
				game.AseFunc(this.x+90, this.y-160);
				game.NikusFunc(this.x, this.y);	//肉ばら撒き
				img = GFXs["Teki63"];
				this.Size = [110,170];
				game.FatSE(this, 3, 0);	//デブ音
			}

		}

		//行動
		switch (this.Action) {

			case 1:	//左へ
			case 2:	//左へ

					this.y += Math.sin(t/12);

					if (this.Timer > (this.Action==1 ? 500:700)) {
						this.gx += 6;
						game.GamenOut(this);	//画面外消失
					} else {
						if (this.Debu<300) this.gx -= 1;
					}
				break;
		}

		game.GoMove2(this, this.gx, this.gy, 0.01);		//座標指定
		game.Move(this);				//慣性移動
		game.MoveLose(this,0.95);		//摩擦

		this.AnimeTimer--;

		//描画
		game.DrawKage(ctxA,img,	this.x,this.y,	this.DrawSize + game.PuyoMan(this,450,0.2),this.DrawSize,	game.Dame(this.Dame),this.AnimeR,	false);
	}

}

//バロンさん
//==============================================================================================
Game.prototype.Baron = function() {
	this.Size = [60,260];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.NikuTimer = 0;
}
Game.prototype.Baron.prototype.Func = function(index) {
	//キホン
	const t = this.Timer;
	let img = "Test";

	game.PlayerBuyon(this,false);		//プレーヤー突き飛ばし

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.05;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=40) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
	} else {
		//this.Debu = Math.max(0,this.Debu-=2);
		//this.Debu += 1;
	}

	let ttt = t;
	switch (this.Action) {
		//初肉
		case 0:
			game.GoMove(this,		250, 0,		100);
			img = "Boss10";
			if (t==200) {
				this.Action = 10;
				this.Timer = 0;
				//this.Debu = 14000;
			}
			break;

		//痩せ
		case 10:
			game.GoMove(this,		300, Math.sin(t/90)*200,		100);
			img = "Boss10";

			ttt = t%250;
			if (ttt<200) {
				img = "Boss11";
				if ((ttt == 50 || ttt == 100 || ttt == 150) && game.LiveShoot()) {
						this.DrawSize -= 0.1;
						this.hx += 3;
						game.TekiTamaPush(this.x-220, this.y,	4,13, PI,		new game.OnoShoot(1,1));
						game.TekiTamaPush(this.x-220, this.y,	2,9, PI,		new game.OnoShoot(1,1));

						game.TekiTamaPush(this.x-220, this.y,	4,-13, PI,		new game.OnoShoot(1,1));
						game.TekiTamaPush(this.x-220, this.y,	2,-9, PI,		new game.OnoShoot(1,1));
						game.PlaySE("Shoot03");		//音
				}
			}

			//移行
			if (this.Debu > 4000) {
				this.Action = 20;
				this.Timer = 300;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA00");		//デブ音
			}
			break;

		//ぽちゃ
		case 20:

			game.GoMove(this,		350, Player.y,		100);
			img = "Boss17";
			ttt = t%400;
			if (ttt<200) {
				img = "Boss16";
				if (ttt>50 && ttt<150) {
					if (ttt%8==0 && ttt%50<25 && game.LiveShoot()) {
						this.DrawSize -= 0.1;
						this.hx += 0.1;
						game.TekiTamaPush(this.x-250, this.y,	5, -4, PI,		new game.OnoShoot(4,1));
						game.PlaySE("Shoot03");		//音
					}
				}
			} else {
				if (t>400 && ttt%30==0 && game.LiveShoot()) {
					this.DrawSize -= 0.05;
					const r = game.PlayerRadis(this.x-50, this.y-100);
					game.TekiTamaPush(this.x-50, this.y-100,	r[0]*7*Rank,r[1]*7*Rank, r[2],		new game.NikuShoot());
					game.PlaySE("Shoot02");		//音
				}
			}


			//移行
			if (this.Debu > 8000) {
				this.Action = 30;
				this.Timer = 450;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA01");		//デブ音
			}
			break;

		//おでぶ
		case 30:
			this.Size = [80,260];
			img = t%80<40 ? "Boss12" : "Boss13";

			ttt = t%500;
			//アックス
			if (ttt<350) {
				img = "Boss14";
				if (ttt%60==0) this.ShootR = game.PlayerRadis(this.x-250, this.y-130);
				if (ttt>50 && ttt<300) {
					if(game.LiveShoot() && ttt%8==0 && ttt%60<30) {
						this.DrawSize -= 0.05;
						const r = this.ShootR;
						game.TekiTamaPush(this.x-280, this.y-130,	r[0]*-10,r[1]*-10, r[2]+PI,		new game.OnoShoot(2,1));
						game.PlaySE("Shoot03");		//音
					}
				}
			game.GoMove(this,		350, 0,		100);
			//ナゲット
			} else if (t>500) {
				if (ttt==350) this.ShootR = Math.random()*5;
				if (ttt<480 && ttt%3==0 && game.LiveShoot()) {
					this.DrawSize -= 0.02;
					const r = Math.sin(this.ShootR)*1.5+game.PlayerRadi(this.x-50, this.y-100);
					const sp = (ttt-450)/30+15;
					game.TekiTamaPush(this.x-50, this.y-100,	Math.cos(r)*sp,Math.sin(r)*sp, r,		new game.NikuShoot());
					this.ShootR += 0.3;
					game.PlaySE("Shoot02");		//音
				}
			game.GoMove(this,		450, 0,		100);
			}

			game.AseFunc2(50,-100, 130, index,this.Key);
			//移行
			if (this.Debu > 14000) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA02");		//デブ音
			}
			break;

		//ぎがでぶ
		case 40:
			this.Size = [100,260];
			game.GoMove(this,		350, Player.y<0 ? 300 : -300,		100);
			img = "Boss15";

			game.AseFunc(this.x+100, this.y-300);
			game.AseFunc2(0,-100, 200, index,this.Key);

			ttt = t%300;
			if (t>100) {
				if (ttt==50) this.ShootR = game.PlayerRadi(this.x-100, this.y-100);
				if (ttt>10) {
					if (t%30==0 && game.LiveShoot()) {
						this.DrawSize -= 0.02;
						let r = this.ShootR + t%60<30 ? TwoPI/16 : 0;
						const sp = (8 + game.Random(3)) * Rank;
						for (let i=0 ; i<TwoPI ;i+=TwoPI/8) {
							game.TekiTamaPush(this.x-100, this.y-100,	Math.cos(r+i)*sp,Math.sin(r+i)*sp, r+i,		new game.NikuShoot());
						}
						this.ShootR += 0.3;
						game.PlaySE("Shoot02");		//音
					}
				}
			}

			//移行
			if (this.Debu > 17000) {
				this.Action = 90;
				this.Timer = 0;
				this.DrawSize = 0.8;
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
			}
			break;

		//決着。
		case 90:
			this.Size = false;
			game.GoMove(this,		300, 0,		80);
			img = "Boss18";
			this.x += t%4<2 ? 2 : -2;

			if (t<100) {
				if (t==1) game.SFXPush(this.x, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {

			} else {
				this.Live = false;
				game.ScoreMan(2000);		//スコア
			}

			break;
	}


	this.hx += Math.cos(t/32)*0.03;
	this.hy += Math.cos(t/16)*0.06;

	game.Move(this);			//慣性移動
	game.MoveLose(this,0.98);		//摩擦

	//描画
	game.DrawKage(ctxA,GFXs[img],	this.x,this.y,	this.DrawSize + game.PuyoMan(this,17000,0.1),this.DrawSize,	game.Dame(this.Dame),false,	false);


}

//ドクターさん　と　デブエットワーゲン
//==============================================================================================
Game.prototype.DrAndDW = function() {
	this.Size = [80,100];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.WalkTimer = 0;
	this.WalkTimer2 = 0;
	this.Jx = 1100,	this.Jy = 60;	//本体座標
	this.CannonRoll = 2;		//主砲実角度
	this.Cannonhx = -1200,		this.Cannonhy = -800;		//主砲目標座標
	this.CannonOff = 250;
	this.NikuTimer = 0;
}
Game.prototype.DrAndDW.prototype.Func = function(index) {

	game.PlayerBuyon(this,false);		//プレーヤー突き飛ばし

	//キホン
	const t = this.Timer;
	let drimg = "Boss200";		//ドクターさんの画像
	let drxoff = -190,	dryoff = -20;	//ドクターさんの座標差分

	//座標
	this.WalkTimer = (this.WalkTimer - (LevelSpeedHX-this.hx) / 55);		//歩き
	const walktimer = this.WalkTimer%TwoPI;
	const walk = -Math.abs(Math.cos(walktimer));		//縦揺れ
	const walklength = 30;								//縦揺れ幅
	const houtoux = this.Jx+40,		houtouy = this.Jy-100 - Math.abs(Math.cos(walktimer+0.1))*walklength;	//砲塔位置
	const houx = houtoux+Math.cos(this.CannonRoll)*520,	houy = houtouy+Math.sin(this.CannonRoll)*520;		//砲先っちょ
	//game.Draw(ctxA,GFXs["Test"],	houx,houy,	1,1,	false,false,	false);	//テスト

	//足音
	const walkt = Math.ceil((this.WalkTimer + HalfPI)/PI);
	if (this.WalkTimer2 != walkt) {
		this.WalkTimer2 = walkt;
		game.PlaySE("Meka00");		//音
	}


	//カノン向き
	/*this.CannonRollH = game.PlayerRadi(houtoux,houtouy);				//プレーヤー狙い
	//ベクトルの外積？
	if (Math.cos(this.CannonRollH)*Math.sin(this.CannonRoll) < Math.sin(this.CannonRollH)*Math.cos(this.CannonRoll)) {
		this.CannonRoll = (this.CannonRoll+0.01) % TwoPI;
	} else {
		this.CannonRoll = (this.CannonRoll-0.01) % TwoPI;
	}*/

	this.CannonRoll = Math.atan2(this.Cannonhy - houtouy,this.Cannonhx - houtoux);	//ゴースト狙い

	this.CannonOff = ((this.CannonOff - 350) * 0.9) + 350;	//カノン食い込み

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.05;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=50) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
	} else {
		//this.Debu += 1;
	}

	//行動
	switch (this.Action) {
		//初肉
		case 0:
			drimg = "Boss201";			//ドクターさんの画像
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			game.MoveLose(this,0.99);		//摩擦
			if (t == 10) this.hx = -10;
			if (t> 200) {
				this.hx += 0.1;
				//this.Cannon(Player.x,Player.y);		//カノン狙い
			}
			if (t > 300) {
				//移行
				this.Timer = 0;
				this.Action = 10;
				//this.Debu = 10000;
			}
			break;

		//ガリ
		case 10:
			this.Size = [80,100];
			drimg = "Boss200";			//ドクターさんの画像
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t%120 > 90) 	this.Cannon(Player.x,Player.y);		//カノン狙い
			if (t>100  && game.LiveShoot()) {
				if (t%120 <90 && t%30==10) {
					this.Fire(houx,houy);
					let radi = this.CannonRoll;
					let speed = Rank * 6;
					//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					speed-=2;
					radi += 0.1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi += -0.2;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi = this.CannonRoll;
					speed = Rank * 6;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));

				}
			}


			//移行
			if (this.Debu > 4000) {
				this.Action = 20;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA00");		//デブ音
			}
			break;

		//ぽちゃ
		case 20:
			this.Size = [80,100];
			drimg = this.DameTimer < 5 ? "Boss203" : "Boss202";			//ドクターさんの画像
			drxoff = -190,	dryoff = -40;	//ドクターさんの座標差分
			game.MoveLose(this,0.8);		//摩擦
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き

			if (t>100  && game.LiveShoot()) {
				if (t%450 < 360) {
					this.Cannon(Player.x,Player.y);		//カノン狙い
					if (t%90 <60 && t%10==5) {
						this.Fire(houx,houy);
						let radi = this.CannonRoll;
						let speed = 5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
					}
				} else {
					if (t%90==5) {
						this.Fire(houx,houy);
						let radi = this.CannonRoll;
						let speed = 5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll+0.5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll-0.5;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll+1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));
						radi = this.CannonRoll-1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(1));

					}
				}
			} else {
				this.Cannon(Player.x,Player.y);		//カノン狙い
			}

			//移行
			if (this.Debu > 8000) {
				this.Action = 30;
				this.Timer = 150;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA01");		//デブ音
			}
			break;

		//でぶぅ（汗）
		case 30:
			game.AseFunc(this.x+100, this.y-100);
			this.Size = [90,130];
			drimg = "Boss204";			//ドクターさんの画像
			drxoff = -230,	dryoff = -20;	//ドクターさんの座標差分
				
			this.hx += (this.x< (t%300>200 ? 550 :400)) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t%300 >180) 	this.Cannon(Player.x,Player.y);		//カノン狙い
			if (game.LiveShoot()) {
				if (t%300 == 20) {
					this.Fire(houx,houy);
					let radi = this.CannonRoll - 0.5;
					let speed = 10 * (3-Rank/2);
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));
					radi -= 0.2;
					if (Rank>1.2) game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));

					radi = this.CannonRoll + 0.5;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));
					radi += 0.2;
					if (Rank>1.2) game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(2));

				}
				if (t%300>200 && t%8 == 0) {

					this.Fire(houx,houy);
					let radi = this.CannonRoll - (400-t%300) / 100 + 0.8;
					let speed = 20;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi = this.CannonRoll + (400-t%300) / 100 - 0.8;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
				}
			}

			//移行
			if (this.Debu > 10000) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA02");		//デブ音
			}
			break;

		//でぶでぶ
		case 40:
			game.AseFunc(this.x+100, this.y-150);
			this.Size = [100,160];
			drimg = t%20<10 ? "Boss205" : "Boss206";			//ドクターさんの画像
			drxoff = -270,	dryoff = 30;	//ドクターさんの座標差分
			this.hx += (Player.x+980>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			this.Cannon(Player.x,Player.y);		//カノン狙い

			if (t>200  && game.LiveShoot()) {
				if (t%120 <90 && t%30==0) {
					this.Fire(houx,houy);
					let radi = this.CannonRoll;
					let speed = 8;
					//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					speed-=0.5* Rank;
					radi += 0.05;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					radi -= 0.1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					if (Rank>1.2) {
						speed-=0.5* Rank;
						radi += 0.05;
						//game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
						radi += 0.1;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
						radi -= 0.2;
						game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));
					}
					radi = this.CannonRoll;
					speed = 8;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, radi,		new game.SoseziShoot(0));

				}
			}


			//移行
			if (this.Debu > 15000) {
				this.Action = 50;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.NikuFunc(this.x, this.y, 5);
				game.PlaySE("FatA02");		//デブ音
			}
			break;

		//ぎがでぶ
		case 50:
			game.AseFunc2(-30,50, 200, index,this.Key);

			this.Size = [200,210];
			drimg = "Boss207";				//ドクターさんの画像
			drxoff = -270,	dryoff = 20;	//ドクターさんの座標差分
			this.hx += (Player.x+1000>this.Jx && this.x<500) ? 0.3 : -0.3;	//歩き
			game.MoveLose(this,0.8);		//摩擦

			if (t>100 && game.LiveShoot()) {
				this.Cannon(this.Jx-1800,this.Jy-1000);		//カノン狙い
				if (t%120 <90 && t%12==0) {
					this.Fire(houx,houy);
					let radi = this.CannonRoll;
					let speed = Math.random()*12 + 1;
					game.TekiTamaPush(houx,houy,	Math.cos(radi)*speed,Math.sin(radi)*speed, this.CannonRoll,		new game.SoseziShoot(10));
				}
			}

			//移行
			if (this.Debu > 20000) {
				this.Action = 60;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
			}
			break;
		//おわり
		case 60:
			game.AseFunc(this.x+100, this.y-250);
			this.Size = false;
			drimg = "Boss207";				//ドクターさんの画像
			drxoff = -270,	dryoff = 20;	//ドクターさんの座標差分
			game.MoveLose(this,0.8);		//摩擦

			if (t<100) {
				this.hx += this.x<200 ? 0.3 : -0.3;	//歩き
				if (t==1) game.SFXPush(this.x-200, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {

			} else {
				this.Live = false;
				game.ScoreMan(2000);		//スコア
			}
			break;
	}


	this.Jx += this.hx;			//移動

	//ドクター移動
	this.x = this.Jx + drxoff + Math.cos(this.WalkTimer)*5;
	this.y = this.Jy + dryoff - Math.abs(Math.cos(this.WalkTimer+0.2))*walklength;

	//描画

	//砲身
	game.DrawKage(ctxB,GFXs["Boss253"],	houtoux+Math.cos(this.CannonRoll)*this.CannonOff,houtouy+Math.sin(this.CannonRoll)*this.CannonOff,	1,1,	false,this.CannonRoll,	false);
	//砲
	game.DrawKage(ctxB,GFXs["Boss252"],	houtoux+Math.cos(this.CannonRoll)*90,houtouy+Math.sin(this.CannonRoll)*90,	1,1,	false,this.CannonRoll,	false);

	//砲塔
	game.DrawKage(ctxB,GFXs["Boss251"],	houtoux,houtouy-40,	1,1,	false,false,	false);

	game.DrawKage(ctxA,GFXs[drimg],	this.x,this.y,	this.DrawSize+0.2 + game.PuyoMan(this,20000,0.1),this.DrawSize+0.2,	game.Dame(this.Dame),false,	false);	//ドクターさん

	//脚
	let walkleg = walktimer + HalfPI;
	const cans = [ctxA,ctxA,ctxB,ctxB];
	const legxs = [-100,200,100,-200],	legys = [250,220,200,180];
	const cols = [false, false, "rgba(50,50,50,50)", "rgba(0,0,0,0.3)"]
	for (let i=0 ; i<4 ; i++) {
		const legx = this.Jx+legxs[i],	legy = this.Jy+legys[i];
		game.Draw(cans[i],GFXs["Boss255"],
			legx+50+ game.heriosan(walkleg)*40,	legy+80 - Math.max(0,(Math.cos(walkleg+HalfPI)))*50,
			1,1,	cols[i],Math.cos(walkleg)/6,	false);
		game.DrawKage(cans[i],GFXs["Boss254"],
			legx-90 + game.heriosan(walkleg)*80,	legy+250 - Math.max(0,(Math.cos(walkleg+HalfPI)))*80,
			1,1,	cols[i],-Math.cos(walkleg)/8,	false);
		walkleg += PI;
	}
	//本体
	game.DrawKage(ctxB,GFXs["Boss250"],	this.Jx,this.Jy+150 - Math.abs(Math.cos(this.WalkTimer))*walklength,	1,1,	false,false,	false);

	//game.DrawKage(ctxA,GFXs["Test"],	this.Jx,this.Jy,	1,1,	false,false,	false);	//テスト
	//game.DrawKage(ctxA,GFXs["Test"],	legx,legy,	1,1,	false,false,	false);	//テスト

	/*ctxUI.fillStyle = "black";
	ctxUI.textAlign = "left";
	ctxUI.font = "bold 20px 'YuMincho'";
	ctxUI.fillText(walkt, 0, 0);*/
}

Game.prototype.DrAndDW.prototype.Fire = function(houx,houy) {
	this.CannonOff = 240;
	game.Draw(ctxB,GFXs["Sfx24"],	houx,houy,	1,1,	false,false,	false);
	game.PlaySE("Shoot02");		//音
}
Game.prototype.DrAndDW.prototype.Cannon = function(x,y) {
	this.Cannonhx = ((this.Cannonhx - x) * 0.9) + x;	//カノン狙い
	this.Cannonhy = ((this.Cannonhy - y) * 0.9) + y;
}

//ペガサス軍曹
//==============================================================================================
Game.prototype.Pegasasu = function() {
	this.nx = 200,	this.ny = 0;
	this.Size = [60,180];
	this.Action = 0;
	this.AttackTimer = 0;
	this.ShootR = 0;
	this.ShootY = 0;
	this.ShootX = 0;
	this.ShootFat = 0;
	this.AnimeTimer = 0;
	this.NikuTimer = 0;
}
Game.prototype.Pegasasu.prototype.Func = function(index) {
	//キホン
	const t = this.Timer;
	let img = "Test";

	game.PlayerBuyon(this,true);		//プレーヤー突き飛ばし

	//ダメージ
	if (this.Dame) {
		this.DrawSize -= 0.03;
		this.PoyoTimer = 1;
		if (this.NikuTimer%10==0 && this.Action>=40) game.NikuFunc(this.x,this.y,1);
		this.NikuTimer++;
		this.AnimeTimer = 80;
	} else {
	}

	let tt = t;
	let r = 0;
	switch (this.Action) {
		//初肉
		case 0:
			img = "Boss300";
			this.y += Math.cos(t/32);
			
			if (t==200) {
				this.Action = 10;
				this.Timer = 0;
				//this.Debu = 20000;
			}
			break;

		//痩せ
		case 10:
			tt = t%100;
			img = "Boss300";
				this.y += Math.cos(t/32);

			if (game.LiveShoot()) {

				//移動
				if (tt == 0) {
					this.nx = game.Random(30)+200;
					this.ny = Player.y+90;
				}

				if (tt > 50) img = "Boss301";

				//射撃
				if (tt < 80 && tt > 60 && tt%5 == 0) {
					const s = (tt-60) / (Rank/2+0.5);
					game.TekiTamaPush(this.x-120, this.y-90,	-s,0, PI,		new game.TeiShoot());
					game.PlaySE("Shoot01");		//音
					this.DrawSize = 0.9;
					this.hx += 5;
				}

			}

			//移行
			if (this.Debu > 3500) {
				this.Action = 20;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.PlaySE("FatA00");		//音
				this.Size = [100,180];
			}
			break;

		//ふとめ
		case 20:
			//if (t%1000 < 500) {
			if (t < 500) {

				//const tt = t%1000;
				const tt = t;

				//7WAY
				img = "Boss320";
				this.y += Math.cos(t/32);
				//移動
				if (t%80 == 0) {
					this.nx = game.Random(100)+300;
					this.ny = game.Random(100)+100;

					this.hx += game.Random(10);
					this.hy += game.Random(10);
				}

				if (tt%40 == 0 && tt>60 && t>100) {
					if (game.LiveShoot()) {
						const r = game.PlayerRadi(this.x-100, this.y-200);

						//撃つ
						const s = 10 + game.Random(5);
						const rl = 0.5;
						for (let i=-rl*3 ; i<=rl*3 ; i+=rl) {
							game.TekiTamaPush(this.x-100, this.y-200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.TeiShoot());
						}
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
					}
				}

			} else {
				//ワインダー

				//const tt = t%1000-500;
				tt = t-500;

				if (tt < 20) {
					//振りかぶり
					img = "Boss321";
					game.MoveLose(this,0.93);		//摩擦
					if (tt == 2) {
						this.hx += 20;
						//this.hy += 20;
						this.nx = 400;
					}
					//this.hx += 1;
				} else {
					//背
					this.hx *= 0,95;
					this.nx = Math.max(300, this.nx - 0.2);
					img = "Boss322";
					//if (tt == 50) this.ShootR = game.PlayerRadi(this.x,this.y);

					const length = 300;	//振る上限	

					//撃ちだす瞬間の設定
					if (tt == 50) {
						this.ShootX = Player.x;
						this.ShootY = Player.y;
						this.ShootFat = Player.y<0;
					}

					//移行か切り替えし
					if (tt>350) {

						if (Math.random()<0.3) {
							//切り返し
							this.ShootFat = Player.y<0;
							this.Timer = 600;

						} else {
							//移行
							this.Timer = 0;
						}
					}

					//連射
					if (tt > 50) {
						//if (t%5 == 0 && game.LiveShoot()) {
						if (t%5 == 0) {

							//上下に振る
							if (tt>200 && tt<300) {
								//const rl = 0.1;
								//r += Math.sin((tt-200)/12) * 0.1;

								const Pls = 15;
								this.ShootY += (this.ShootFat ? Pls : -Pls);
							}

							this.ShootY = Math.min(length, Math.max(-length,this.ShootY));
							let r = game.Radi(this.x,this.y, this.ShootX,this.ShootY );

							//撃つ
							//const s = Math.min(40, tt-50)+10;
							const s = 50;
							for (let i=-0.5 ; i<=0.5 ; i+=0.5) {
								game.TekiTamaPush(this.x+30, this.y+200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.HaneShoot());
							}
							for (let i=-0.5 ; i<=0.5 ; i+=0.5) {
								game.TekiTamaPush(this.x+30, this.y-200,	Math.cos(r+i)*s,Math.sin(r+i)*s, r+i,		new game.HaneShoot());
							}
							game.PlaySE("Shoot02");		//音
						}
					}
				}
			}

			//移行
			if (this.Debu > 10000) {
				this.Action = 30;
				this.Timer = 100;
				this.DrawSize = 0.5;
				game.PlaySE("FatA02");		//音

				this.ShootFat = true;
				this.ShootR = 0;

				this.Size = [150,220];
			}
			break;

		//巨デブ
		case 30:
			img = "Boss330";
			if (t > 280) img = "Boss331";

			//移動
			this.ny = Math.sin(Loop/128) * 150;

			if (t<300) {
				this.nx = 200;
			} else {
				this.nx = Math.min(500, this.nx+1);
			}
			//if () {

				if (this.ShootFat) {

					//ばら撒き
					if (t > 300 && t%20 == 0 && game.LiveShoot()) {
						const s = 8 * Rank;
						const r = Math.max(-0.6,Math.min(0.6,	Math.cos(this.ShootR)	)) + PI;
						if (t%40 < 5) {
							game.TekiTamaPush(this.x-200, this.y-130,	Math.cos(r)*s,Math.sin(r)*s, r,		new game.TeiShoot());
							game.TekiTamaPush(this.x-200, this.y+130,	Math.cos(r)*s,Math.sin(r)*s, r,		new game.TeiShoot());
						} else {
							const rr = TwoPI-r;
							game.TekiTamaPush(this.x-200, this.y-130,	Math.cos(rr)*s,Math.sin(rr)*s, rr,		new game.TeiShoot());
							game.TekiTamaPush(this.x-200, this.y+130,	Math.cos(rr)*s,Math.sin(rr)*s, rr,		new game.TeiShoot());
						}
						game.PlaySE("Shoot01");		//音
						this.DrawSize = 0.9;
						this.ShootR += PI/16;
					}
				} else {
					//羽
					if (t > 400 && t%5 == 0) {
						const rt = Loop/64;
						const plsr = TwoPI/3;
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt)*100,	-40,0, PI,		new game.HaneShoot());
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt+plsr)*100,	-40,0, PI,		new game.HaneShoot());
						game.TekiTamaPush(this.x-190, this.y+Math.cos(rt+plsr+plsr)*100,	-40,0, PI,		new game.HaneShoot());
						game.PlaySE("Shoot02");		//音
						this.DrawSize -= 0.01;
					}
				}

			//}

			if (t > 500 && t%30 == 0 && Math.random()<0.1) {
				this.Timer = Math.ceil(150 + Math.random()*100);
				this.ShootFat = Math.random()<0.7;;
			}

			//移行
			if (this.Debu > 19000) {
				this.Action = 40;
				this.Timer = 0;
				this.DrawSize = 0.5;
				game.PlaySE("FatA02");		//音
				this.Size = [230,230];
				this.nx = 250;
			}
			break;

		//メガデブ
		case 40:
			game.AseFunc(this.x+50, this.y-250);

			tt = t%300;

			const imgs = ["Boss340",	"Boss342",	"Boss340",	"Boss341"];
			img = imgs[Math.ceil(this.AnimeTimer/2)%4];
			this.AnimeTimer *= 0.95;

			//移動
			this.ny = Math.sin(Loop/128) * 200;

			if (game.LiveShoot()) {

				//射撃
				if (tt > 50 && tt%30 == 0) {
					const s = 8 * Rank;

					game.PlaySE("Shoot01");		//音
					game.TekiTamaPush(this.x-100+game.Random(100), this.y+game.Random(200),	-s,0, PI,		new game.NInzinShoot());
					this.DrawSize = 0.95;
					this.hx += 5;
				}

				if (t > 300) {

					let r = (t)%TwoPI;

					if (r<TwoPI-0.5 && r>0.5) {
						r += PI;
						const s = 15;
						game.TekiTamaPush(this.x+Math.cos(r)*200, this.y+Math.sin(r)*200,	Math.cos(r)*s,Math.sin(r)*s,r,		new game.HaneShoot());
					}
				}

			}

			//移行
			if (this.Debu > 25000) {
				this.Action = 500;
				this.Timer = 0;
				this.DrawSize = 0.2;
				game.PlaySE("FatA02");		//音
				game.PhaseUP2();
				game.NikuFunc(this.x, this.y, 50);
				//this.nx = 200;
				//this.ny = 0;
				this.Size = false;
			}
			break;

		//脂肪
		case 500 :

			this.x += Loop4 ? -3 : 3;

			img = "Boss343";

			if (t<100) {
				if (t==1) game.SFXPush(this.x, this.y,	0,0,	0, new game.BigBoom(200));
			} else if (t<400) {
			} else {
				this.Live = false;
				game.ScoreMan(3000);		//スコア
			}
			break;
	}

	game.Move(this);				//慣性移動
	game.MoveLose(this,0.95);		//摩擦
	game.GoMove2(this, this.nx, this.ny, 0.03);		//座標指定

	//描画
	game.DrawKage(ctxA,GFXs[img],	this.x, this.y,	this.DrawSize + game.PuyoMan(this,25000,0.1),this.DrawSize,	game.Dame(this.Dame),false,	false);

}
//==============================================================================================
//==============================================================================================
//==============================================================================================