//自機弾プッシュ
Game.prototype.ZikiTamaPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(ZikiTamas);
	ZikiTamas[i]=data;
	//そして基本的情報を挿入
	game.TamaKiso(ZikiTamas[i],x,y,hx,hy,radi);
}

//敵弾プッシュ
Game.prototype.TekiTamaPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(TekiTamas);
	TekiTamas[i]=data;
	//基本的情報を挿入
	game.TamaKiso(TekiTamas[i],x,y,hx,hy,radi);
}

//エフェクトプッシュ
Game.prototype.SFXPush = function(x,y,hx,hy,radi,data) {
	const i = game.NullFined(SFXs);
	SFXs[i]=data;
	//そして基本的情報を挿入
	game.TamaKiso(SFXs[i],x,y,hx,hy,radi);
}

//弾の基本情報
Game.prototype.TamaKiso = function(data,x,y,hx,hy,r) {
	data.Live = true;			//生存確認
	data.x = x,	data.y = y;	//座標
	data.hx = hx,	data.hy = hy;	//慣性（正確でない）
	data.Radi = r;			//方角性（正確でない）
	data.Timer = 0;			//タイマー

}

//汗
//==============================================================================================
Game.prototype.Ase = function() {
}
Game.prototype.Ase.prototype.Func = function(index) {
	if (this.Timer < 20) {
		this.hx = Math.cos(this.Radi)*8;
		this.hy = Math.sin(this.Radi)*8;
		game.Move(this);		//慣性移動
		this.Radi += 0.02;
		game.Draw(ctxA,GFXs["Sfx02"],	this.x,this.y,	1,1,	false,this.Radi,	false);
	} else {
		this.Live = false;
	}
}

//汗2
//==============================================================================================
Game.prototype.Ase2 = function(ind,key,gx,gy) {
	this.Index = ind,	this.Key = key;
	this.gx = gx,	this.gy = gy;
}
Game.prototype.Ase2.prototype.Func = function(index) {
	if (this.Timer < 300) {
		if (this.Timer<100 && game.CallSprite(this.Index,this.Key)) {
			this.x = Sprites[this.Index].x + this.gx;
			this.y = Sprites[this.Index].y + this.gy;
			this.gy += 0.5;
		} else {
			this.hy += 0.2;
			game.Move(this);		//慣性移動
			game.GamenOut(this);	//画面外消失
		}
		const size = Math.min(1, this.Timer/50)*0.8;
		game.Draw(ctxA,GFXs["Sfx03"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//花火
//==============================================================================================
Game.prototype.Stars = function() {
}
Game.prototype.Stars.prototype.Func = function(index) {
	if (this.Timer < 120) {
		const size = Math.sin(this.Timer/120*PI)*200;
		const sizee = 1-Math.sin(this.Timer/120*HalfPI);
		for (let r=this.Timer/20 ; r<8 ; r+=TwoPI/8) {
			game.Draw(ctxA,GFXs[Loop8 ? "Sfx23" : "Sfx20"],this.x+Math.cos(r)*size,this.y+Math.sin(r)*size,
				sizee,sizee,	false,0,	false);	
		}
		if (this.Timer<30) {
			const sizeee = 1-Math.sin(this.Timer/30*HalfPI);
			game.Draw(ctxA,GFXs["Sfx21"],this.x,this.y,	sizeee,sizeee,	
			Loop4 ? "rgba(255,0,0,0.8)" : "rgba(255,255,0,0.8)",0,	false);
		}
	} else {
		this.Live = false;
	}
}

//肉火花
//==============================================================================================
Game.prototype.FatSlag = function() {
}
Game.prototype.FatSlag.prototype.Func = function(index) {
	if (this.Timer < 30) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.98);		//摩擦
		const size = Math.sin(this.Timer/30*PI);
		game.Draw(ctxA,GFXs["Sfx00"],	this.x,this.y,	size,size,	false,this.Radi,	false);
	} else {
		this.Live = false;
	}
}
//肉火花2
//==============================================================================================
Game.prototype.FatSlag2 = function() {
}
Game.prototype.FatSlag2.prototype.Func = function(index) {
	if (this.Timer < 40) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.95);		//摩擦
		const size = Math.sin(this.Timer/40*HalfPI + HalfPI);
		game.Draw(ctxB,GFXs["Sfx01"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//飛び散った脂肪片
//==============================================================================================
Game.prototype.FatBall = function() {
	this.Size = Math.random()/2+0.5;
}
Game.prototype.FatBall.prototype.Func = function(index) {
	//this.hy += this.Size/6;
	this.hy += 0.08;
	game.Move(this);			//慣性移動
	img = ["Sfx40","Sfx41","Sfx42","Sfx43"];
	img = GFXs[img[Math.floor(index%4)]];

	const size = Math.sin(this.Timer/30*PI);
	game.Draw(ctxB,img,	this.x,this.y,	this.Size+((Math.random()-0.5)/4),this.Size+((Math.random()-0.5)/4),
		false,false,	false);
	game.GamenOut(this);	//画面外消失
}

//汎用飛沫
//==============================================================================================
Game.prototype.Himatu = function(i) {
	this.Roll = Math.random() * PI;
	this.IMG = i;
	this.End = 80 + Math.random()*50;
}
Game.prototype.Himatu.prototype.Func = function(index) {
	if (this.Timer < this.End) {
		game.Move(this);			//慣性移動
		//game.MoveLose(this,0.98);		//摩擦
		this.hy+=0.2;
		game.Draw(ctxB,GFXs[this.IMG],	this.x,this.y,	1,1,	false,this.Roll,	false);
		//game.GamenOut(this);	//画面外消失
	} else {
		this.Live = false;
	}
}

//血
//==============================================================================================
Game.prototype.Ti = function() {
	this.Size = Math.random()/2+0.5;
}
Game.prototype.Ti.prototype.Func = function(index) {
	if (this.Timer < 60) {
		game.Move(this);			//慣性移動
		game.MoveLose(this, 0.98);		//摩擦
		this.hy+=0.4;
		const size = Math.sin(this.Timer/60*HalfPI + HalfPI);
		game.Draw(ctxB,GFXs["Sfx52"],	this.x,this.y,	size,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//マズルフラッシュ
//==============================================================================================
Game.prototype.ShootSibuki = function() {
	this.Size = Math.random()/2+0.5;
}
Game.prototype.ShootSibuki.prototype.Func = function(index) {
	if (this.Timer < 8) {

		const size = (8-this.Timer)/8;
		game.Draw(ctxA,GFXs["Sfx04"],	this.x,this.y,	0.5,size,	false,false,	false);
	} else {
		this.Live = false;
	}
}

//爆発
//==============================================================================================
Game.prototype.BigBoom = function(s) {
	this.Length = s;
}
Game.prototype.BigBoom.prototype.Func = function(index) {
	const t = this.Timer;
	if (t < 500) {
		if (t<200) {
			if (t%10 == 0) {
				game.FatSlagsFunc(this.x+game.Random(this.Length),this.y+game.Random(this.Length),10);
			}
			if (t%80 == 0) game.SFXPush(this.x+game.Random(this.Length),this.y+game.Random(this.Length), 0,0, 0,	new game.Stars());
		} else {
			if (t<400) {
				Blacking = Math.min(1,Blacking+0.01);
				for (let i=0 ; i<3 ; i++) {
					const r = Math.random()*TwoPI;
					const s = Math.random()*20+20;
					game.SFXPush(this.x,this.y,	Math.cos(r)*s,Math.sin(r)*s,	r, new game.FatSlag2());
				}
			} else {
				Blacking = 0;
			}
			const size = Math.sin(((t-200)/300*PI))*10;
			const r = Math.random();
			game.Draw(ctxBG2,GFXs["Sfx22"],	this.x,this.y,	size,size,	false,r,	false);
			game.Draw(ctxUI,GFXs["Sfx22"],	this.x,this.y,	size,size,	false,r,	[0,(t-200)/200]);
		}
	} else {
		this.Live = false;
				for (let i=0 ; i<10 ; i++) {
					const r = Math.random()*TwoPI;
					const s = Math.random()*20+5;
					game.SFXPush(this.x,this.y,	Math.cos(r)*s,Math.sin(r)*s,	r, new game.FatSlag2());
				}
	}
}

//呪われたチーズ（1万カロリー）
//==============================================================================================
Game.prototype.TizuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.TizuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	for (let h=4 ; h>=0 ; h--) {
		size = 1-h/6;
		game.Draw(ctxB,GFXs["Tama20"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama10"],	this.x,this.y,	1,1,	false,-this.Timer/12+index,	false);
}


//違法ナゲット（２万カロリー）
//==============================================================================================
Game.prototype.NikuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.NikuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama15"],	this.x,this.y,	1,1,	false,false,		false);
		game.Draw(ctxB,GFXs["Tama23"],	this.x,this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//悪魔の人参（0.7万カロリー）
//==============================================================================================
Game.prototype.NInzinShoot = function() {
	this.Size = [20,20];
}
Game.prototype.NInzinShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	for (let h=4 ; h>=0 ; h--) {
		size = 1-h/6;
		game.Draw(ctxB,GFXs["Tama21"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}

	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama12"],	this.x,this.y,	1,1,	false,this.Radi,	false);
}

//トゲ
//==============================================================================================
Game.prototype.HariShoot = function() {
	this.Size = [10,10];
}
Game.prototype.HariShoot.prototype.Func = function(index) {
	if (this.Timer < 20) {

		game.Move(this);			//慣性移動
		game.MoveLose(this,0.95);		//慣性移動

		game.Draw(ctxB,GFXs["Tama21"],
			this.x,this.y, 0.7,0.7,	false,Math.random(),	["add"]);
		game.Draw(ctxA,GFXs["Tama11"],	this.x,this.y,	1,1,	false,false,	false);

		//当たり
		if (game.PlayerHit(this)) {
			this.Live = false;
			game.PlayerKill(2);
		}
	} else {
		this.Live = false;
	}
}

//デスお稲荷（１万カロリー）
//==============================================================================================
Game.prototype.OinariShoot = function() {
	this.Size = [30,30];
}
Game.prototype.OinariShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		//減加速
		if (this.Timer<50) {
			game.MoveLose(this,0.98);		//摩擦
			//this.Radi = game.PlayerRadi(this.x, this.y);
		} else if (this.Timer<80) {
			this.hx += Math.cos(this.Radi) *Rank / 8;
			this.hy += Math.sin(this.Radi) *Rank / 8;
		}

		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama17"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		for (let h=4 ; h>=0 ; h--) {
			size = (1-h/6);
			game.Draw(ctxB,GFXs["Tama21"],
				this.x-this.hx*h*2, this.y-this.hy*h*2,
				size,size,	false,Math.random(),	["add"]);
		}
	}
}

//魔改造フランスパン（2万カロリー）
//==============================================================================================
Game.prototype.FuramsuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.FuramsuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {

		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama18"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		for (let h=4 ; h>=0 ; h--) {
			size = (1-h/6)*1.5;
			game.Draw(ctxB,GFXs["Tama24"],
				this.x-this.hx*h*4, this.y-this.hy*h*4,
				size,size,	false,Math.random(),	["add"]);
		}
	}
}

//カロリーナッツ（５千カロリー）
//==============================================================================================
Game.prototype.NattuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.NattuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	if (this.Timer < 60) {
		const s = this.Timer / 6 * Rank;
		this.hx = Math.cos(this.Radi)*s;
		this.hy = Math.sin(this.Radi)*s;
	}

	for (let h=4 ; h>=0 ; h--) {
		size = (1-h/6)*0.8;
		game.Draw(ctxB,GFXs["Tama21"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	game.Draw(ctxA,GFXs["Tama31"],	this.x,this.y,	1,1,	false,this.Radi,	false);
}

//デブハム（５兆カロリー）
//==============================================================================================
Game.prototype.HamuShoot = function() {
	this.Size = [30,30];
}
Game.prototype.HamuShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	game.GamenOut(this);		//画面外消失

	/*if (this.Timer < 60) {
		const s = this.Timer / 6 * Rank;
		this.hx = Math.cos(this.Radi)*s;
		this.hy = Math.sin(this.Radi)*s;
	}*/

	for (let h=4 ; h>=0 ; h--) {
		size = (1-h/6)*1.1;
		game.Draw(ctxB,GFXs["Tama20"],
			this.x-(Math.cos(this.Radi)*h*15),this.y-(Math.sin(this.Radi)*h*15),
			size,size,	false,Math.random(),	["add"]);
	}
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	}
	const s = Math.cos(Loop/2+index)/8+1;
	game.Draw(ctxA,GFXs["Tama32"],	this.x,this.y,	s,s,	false,this.Radi+0.3,	false);
}

//フェザーカッター
//==============================================================================================
Game.prototype.HaneShoot = function() {
	this.Size = [30,30];
}
Game.prototype.HaneShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(1);
	} else {
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama30"],	this.x,this.y,	1,1,		false,this.Radi,		false);
		game.Draw(ctxB,GFXs["Tama21"],	this.x, this.y,	1.5,1.5,	false,Math.random(),	["add"]);
	}
}

//羽馬の蹄鉄
//==============================================================================================
Game.prototype.TeiShoot = function() {
	this.Size = [20,20];
}
Game.prototype.TeiShoot.prototype.Func = function(index) {
	//当たり
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(2);
	} else {
		game.Move(this);			//慣性移動
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama19"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		game.Draw(ctxB,GFXs["Tama20"],	this.x, this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//デスアックス
//==============================================================================================
Game.prototype.OnoShoot = function(ty,s) {
	this.Size = [50*s,50*s];
	this.Deka = s;
	this.Type = ty;
	this.kx = 0;	this.ky = 0;
}
Game.prototype.OnoShoot.prototype.Func = function(index) {
	const t = this.Timer;
	game.GamenOut(this);		//画面外消失
	game.Move(this);			//慣性移動
	switch (this.Type) {
		case 1 :
			this.hy *= 0.95;
			this.hx -= 0.2;
			break;
		case 2:
			if (this.Timer<15) {
				game.MoveLose(this,0.97);
			} else if (this.Timer<30) {
				const r = game.PlayerRadis(this.x, this.y);
				this.hx += r[0] * Rank;
				this.hy += r[1] * Rank;
			}
			break;
		case 3:
			if (t==0) {
				this.kx = -this.hx;
				this.ky = -this.hy;
			} else if (t<15) {
				game.MoveLose(this,0.97);
			} else if (t<45) {
				this.hx += this.kx*0.002 * Rank/2;
				this.hy += this.ky*0.002 * Rank/2;
			}
			break;

		case 4:
			if (this.Timer<15) {
				game.MoveLose(this,0.95);
			} else {
				if (this.Timer>20) this.hy += (this.y<Player.y ? 0.1 : -0.1) * Rank;
				this.hx -= 0.3;
			}
			break;
	}

	for (let h=4 ; h>=0 ; h--) {
		size = (1-h/4)*2;
		game.Draw(ctxB,GFXs["Tama22"],
			//this.x-(Math.cos(this.Radi)*h*40),this.y-(Math.sin(this.Radi)*h*40),
			this.x-this.hx*h*2, this.y-this.hy*h*2,
			size,size,	false,Math.random(),	["add"]);
	}

	//当たり
	if (game.PlayerHit(this)) {
		//this.Live = false;
		game.PlayerKill(1);
	}

	game.Draw(ctxA,GFXs["Tama13"],	this.x,this.y,	1,1,	false,-this.Timer/6+index,	false);
}

//謎肉ソーセージ（１万カロリー）
//==============================================================================================
Game.prototype.SoseziShoot = function(t) {
	this.Size = [30,30];
	this.Type = t;
}
Game.prototype.SoseziShoot.prototype.Func = function(index) {
	game.Move(this);			//慣性移動
	let img = "Tama24";
	//当たりs
	if (game.PlayerHit(this)) {
		this.Live = false;
		game.PlayerKill(0);
	} else {
		switch (this.Type) {
			case 0:
				break;
			//減加速
			case 1:
				img = "Tama20";
				if (this.Timer<50) {
					game.MoveLose(this,0.98);		//摩擦
					//this.Radi = game.PlayerRadi(this.x, this.y);
				} else {
					this.hx += Math.cos(this.Radi) *Rank / 4;
					this.hy += Math.sin(this.Radi) *Rank / 4;
				}
				break;
			//置いてく
			case 2:
				img = "Tama21";
				if (this.Timer>2 && this.Timer%20==15 && this.x>-500) {
					game.TekiTamaPush(this.x, this.y,	0,0, 0,		new game.SoseziShoot(3));
				}
				this.hy *= 0.98;
				break;
			//向かって加速
			case 3:
				img = "Tama20";
				if (this.Timer<100) {
					if (game.LiveShoot()) this.Radi = game.PlayerRadi(this.x, this.y);
				} else {
					this.hx += Math.cos(this.Radi) *Rank / 8;
					this.hy += Math.sin(this.Radi) *Rank / 8;
				}
				break;
			case 10:
				//Math.min(-HalfPI,this.Radi-0.1);
				this.Radi -= this.hx/50;
				this.hx *= 0.995;
				this.hy += (Rank)*0.1;
				this.hy *= 0.98;
				break;
		}
		game.GamenOut(this);		//画面外消失
		game.Draw(ctxA,GFXs["Tama16"],	this.x,this.y,	1,1,	false,this.Radi,		false);
		game.Draw(ctxB,GFXs[img],	this.x,this.y,	1,1,	false,Math.random(),	["add"]);
	}
}

//自機の脂肪弾
//==============================================================================================
Game.prototype.ZikiFatShoot = function(p,h) {
	this.Size = [40,10];
	this.Pow = p;
	this.Height = h;
}
Game.prototype.ZikiFatShoot.prototype.Func = function(index) {

	const atari = game.Ataris(this);

	//着弾
	if (atari != null) {
		this.Live = false;
		Sprites[atari].Debu += this.Pow;
		Sprites[atari].Dame	 =  true;
		Sprites[atari].DameTimer = 0;

		game.PlaySE("Hit00");
		game.ScoreMan(1);		//スコア

		//for (var i=0 ; i<2 ; i++ ) {
			const rad = game.Random(1);
			const speed = Math.random()*5+5;
			game.SFXPush(this.x, this.y,	Math.cos(rad)*speed, Math.sin(rad)*speed,	rad,	new game.FatSlag());
		//}

	}

	game.Move(this);		//慣性移動
	game.GamenOut(this);	//画面外消失
	//描画
	game.Draw(ctxA,GFXs["Tama00"],	this.x,this.y,	1,this.Height,	false,this.Radi,	false);
}
//ビット柴
//==============================================================================================
Game.prototype.BitSiba = function() {
	this.Size = [60,80];
}
Game.prototype.BitSiba.prototype.Func = function(index) {
	if (this.Timer<300) {
		if (this.x>200) this.x -= 2;
	} else if (this.Timer<400) {
	} else {
		game.GamenOut(this);	//画面外消失
		this.x -= 5;
	}

	//当たり
	if (game.Atari2(Player,this) && Player.Live) {
		if (Player.Sibas.length<2) {
			game.GetSiba();
		} else {
			game.ScoreMan(800);		//スコア
		}
			this.Live = false;
	}

	game.DrawKage(ctxA,GFXs[Loop8 ? "Player22" : "Player23"],	this.x,this.y,
		0.7+Math.cos(this.Timer/6)/10,0.7-Math.cos(this.Timer/6)/10,	false,-this.Timer/32+index,	false);

	game.Draw(ctxA,GFXs["Text30"],	this.x,this.y+40,	1,1,	false,false,	false);
}

//アイテム肉
//==============================================================================================
Game.prototype.NikuNiku = function() {
	this.Size = [60,60];
	this.Tobi = false;
}
Game.prototype.NikuNiku.prototype.Func = function(index) {
	if (this.Tobi) {
		const r = game.PlayerRadis(this.x, this.y);
		this.x += r[0] * this.Timer;
		this.y += r[1] * this.Timer;
	} else {
		if (!game.SHOOT(true) && game.LiveShoot()) {
			this.Tobi = true;
			this.Timer = 0;
		}
		this.hy += 0.1;
		game.MoveLose(this,0.98);	//摩擦
		game.GamenOut(this);	//画面外消失
	}
	game.Move(this);			//慣性移動

	//当たり
	if (game.Atari2(Player,this)) {
		game.ScoreMan(10);		//スコア
		if (Player.DrawSize>0.7) Player.DrawSize -= 0.1;
		this.Live = false;
	}

	const size = (Math.random()*2+6)*0.1;
	game.Draw(ctxA,GFXs["Tama01"],	this.x,this.y,	size,size,	false,false,	false);
}

//開始文字
//==============================================================================================
Game.prototype.StartTextMan = function(img) {
	this.Img = img;
}
Game.prototype.StartTextMan.prototype.Func = function(index) {
	if (this.Timer < 300) {
		if (this.Timer<200) {

			ctxUI.fillStyle = "black";
			ctxUI.globalAlpha = Math.min(0.5, this.Timer/50);
			game.FillCan(ctxUI);
			ctxUI.globalAlpha = 1;

			ctxUI.save();
			ctxUI.beginPath();
			ctxUI.rect(-WidthHalf, -HeightHalf, Width, this.Timer*10);
			ctxUI.clip();
			game.Draw(ctxUI,GFXs[this.Img],	0,ScreenY,	1,1,	false,false,	false);
			ctxUI.restore();
			
		} else {
			if (Loop%20<15) game.Draw(ctxUI,GFXs["Text20"],	0+game.Random(2),ScreenY+game.Random(2),	1,1,	false,false,	false);
			ctxUI.fillStyle = "black";
			ctxUI.globalAlpha = 0.5-Math.min(0.5, (this.Timer-200)/50);
			game.FillCan(ctxUI);
			ctxUI.globalAlpha = 1;
		}
	} else {
		this.Live = false;
	}
}

//文字
//==============================================================================================
Game.prototype.BossTextMan = function() {
}
Game.prototype.BossTextMan.prototype.Func = function(index) {

	if (this.Timer < 200) {
			ctxUI.globalAlpha = 0.8;
			const size = Math.sin((this.Timer/20)/PI)*40;

			ctxUI.beginPath();
			ctxUI.save();
			ctxUI.rect(-WidthHalf,-HeightHalf,WidthHalf,Height);
			ctxUI.clip();
			for (var i=-1 ; i<1 ; i++) {
				const offx = (-Loop*20)%600 + i*600;
				ctxUI.drawImage(GFXs["Text23"],	offx,-size,	600,size*2);
			}
			ctxUI.restore();
			ctxUI.save();
			ctxUI.beginPath();
			ctxUI.rect(0,-HeightHalf,WidthHalf,Height);
			ctxUI.clip();
			for (var i=-1 ; i<1 ; i++) {
				const offx = (Loop*20)%600 + i*600;
				ctxUI.drawImage(GFXs["Text22"],	offx,-size,	600,size*2);
			}
			ctxUI.restore();
			ctxUI.globalAlpha = 1;

		if (this.Timer>50) {
			if (Loop%20<15) game.Draw(ctxUI,GFXs["Text21"],	0+game.Random(2),ScreenY+game.Random(2),	1,1,	false,false,	false);
		}
	} else {
		this.Live = false;
	}
}
//LEVEL終了
//==============================================================================================
Game.prototype.EndTextMan = function(t,l) {
	this.Type = t;
	this.Level = l;
}
Game.prototype.EndTextMan.prototype.Func = function(index) {
	const t = this.Timer;

	if (t<200) {
		BlackFlag = true;
	}
	if (t==200) {
		//game.WallCall();
		switch (this.Type) {
			case 0:
				game.LevelPush(this.Level);
				this.Live = false;

				break;
		}
	}
}
//==============================================================================================
//==============================================================================================
//==============================================================================================