//描画
//======================================================================================
Game.prototype.Draw = function(can,img, x,y, sx,sy, color,radi, out) {
	if (sy>0 && sx>0) {
		Draws++;
		const sizex = img.width*sx;
		const sizey = img.height*sy;
		can.save();
		can.translate(x,y - (out[2] ? 0 : ScreenY));
		//回転
		if (Math.abs(radi) > 0.001) can.rotate(radi);
		//色
		if (color != false) {
			canvasD.width = img.width;
			canvasD.height = img.height;
			ctxD.clearRect(0, 0, canvasD.width, canvasD.height);
			ctxD.drawImage(img,0,0);
			ctxD.globalCompositeOperation = "source-atop";
			ctxD.fillStyle = color;
			ctxD.fillRect(0, 0, canvasD.width, canvasD.height);
			img = canvasD;
		}
		//細かい描画設定
		if (out != false) {
			if (out[0] == "add") {
				can.globalCompositeOperation = "lighter";
			} else if (out[0] == "kage") {
				can.globalCompositeOperation = "source-atop";
			}
			if (out[1] != undefined) {
				can.globalAlpha = out[1];
			}
		}
		//描画
		can.drawImage(img, -sizex>>1, -sizey>>1, sizex, sizey);
		can.restore();
	}
}
Game.prototype.DrawKage = function(can,img, x,y, sx,sy, color,radi, out) {
	game.Draw(can,img, x,y, sx,sy, color,radi, out);
	if (LevelKage != false) game.Draw(ctxBG2,img, x+LevelKage[1],y+LevelKage[2], sx,sy, LevelKage[0],radi,	["kage",0.4]);
	//if (LevelKage != false && Loop2) game.Draw(ctxBG2,img, x+LevelKage[1],y+LevelKage[2], sx,sy, LevelKage[0],radi,	["kage"]);
}
Game.prototype.DrawSS = function(can,img, x,y,z, sx,sy, color,radi, out) {
	//if (z>0) {
		const zz = z/200;
		x = x/zz;
		y = (y-ScreenY)/zz;
		sx = sx/zz;
		sy = sy/zz;
		out = [out[0],out[1],true];
		game.Draw(can,img, x,y, sx,sy, color,radi, out);
	//}
}

//音
//======================================================================================
Game.prototype.PlaySE = function(sound) {
	if (SEVolume <= 0) return;
	var id = SOUNDs[sound].src;
	if (SoundFlags.some( function(element){return (element==id)} ) ==false) {
		SOUNDs[sound].volume = SEVolume;
		SOUNDs[sound].currentTime = 0;
		SOUNDs[sound].play();
		SoundFlags.push(id);

		//SOUNDs[sound] = new Audio(id);
	}
}
//肥満化音
//======================================================================================
Game.prototype.FatSE = function(fat, a, type) {
	if (fat.Fat == a) return;	//同じなら帰る

	//前よりデブった
	if (fat.Fat < a) {
		const ses = ["SE00", "FatA00", "FatA01", "FatA02", "FatA02"];
		game.PlaySE(ses[a]);
	}

	fat.Fat = a;
}

//ゲームエンジン
//======================================================================================
//フェーズ移行
Game.prototype.PhaseUP = function(fat) {
	LevelPhase = fat;
	LevelPhaseTimer = 0;
}
Game.prototype.PhaseUP2 = function() {
	LevelPhase++;
	LevelPhaseTimer = 0;
}

//ゲームオーバー
Game.prototype.GameOvarFunc = function() {
	GameMode = "GAMEOVER"
}

//画面移行
Game.prototype.WallCall = function() {
	WallTimer = 2;
}
//ゲーム操作
//======================================================================================
//ランク操作
Game.prototype.RankMan = function(fat) {
	const bbw = 10000000;
	Rank = Math.round(Math.min(2, Math.max(1, Rank+fat)) * bbw) / bbw;
}

//スコア加算
Game.prototype.ScoreMan = function(fat) {
	Score += fat;
}

//カンヴァス消し
Game.prototype.ClearCan = function(fat) {
	fat.beginPath();
	fat.clearRect(-WidthHalf, -HeightHalf, Width, Height);
}

//カンヴァス塗り
Game.prototype.FillCan = function(fat) {
	fat.beginPath();
	fat.fillRect(-WidthHalf, -HeightHalf, Width, Height);
}

//数字
Game.prototype.DrowSuuzi = function(text) {
	var size = 78;
	var texs = new String(Math.round(text));
	canvasD.width = texs.length*size;
	canvasD.height = 88;
	ctxD.clearRect(0, 0, canvasD.width, canvasD.height);
	ctxD.globalAlpha = 1;

	for (var i=0 ; i<texs.length ; i++) {
		ctxD.drawImage(GFXs["Text01"],
				texs.substr(i,1)*size,0,	size,88,
				i*size,0,			size,88	);
	}

}

//canvas塗り
Game.prototype.FillOn = function(fat,col,a) {
	fat.globalAlpha = a;
	fat.globalCompositeOperation = "source-atop";
	fat.fillStyle = col;
	fat.fillRect(-WidthHalf, -HeightHalf, Width, Height);
	fat.globalCompositeOperation = "source-over";
	fat.globalAlpha = 1;
}

//当たり判定を表示
Game.prototype.DrawAtari = function(sps,color) {
	//if (Loop2) {
		ctxUI.strokeStyle = color;
		ctxUI.fillStyle = color;
		ctxUI.lineWidth = 3;
		for (var i=0;i<sps.length;i++) {
			if (sps[i] != null) {
				if (sps[i].Size != undefined) {
					ctxUI.beginPath();
					if (sps[i].Dame != true) {
						ctxUI.globalAlpha = Loop2 ? 1 : 0.5;
						ctxUI.strokeRect( sps[i].x-sps[i].Size[0], sps[i].y-sps[i].Size[1]-ScreenY,
							sps[i].Size[0]<<1, sps[i].Size[1]<<1 );
					} else {
						ctxUI.globalAlpha = 1;
						ctxUI.fillRect( sps[i].x-sps[i].Size[0], sps[i].y-sps[i].Size[1]-ScreenY,
							sps[i].Size[0]<<1, sps[i].Size[1]<<1 );
					}
				}
			}
		}
	//}
	ctxUI.globalAlpha = 1;
}

//文字重ね
Game.prototype.DText = function(ctx,fat,x,y) {
		ctx.strokeText(fat, x, y);
		ctx.fillText(fat, x, y);
}

//数学
//======================================================================================
//なめらか
Game.prototype.Name = function(a,b,bbw) {
	return ((a-b) * bbw) + b;
}

//なめらか２
Game.prototype.Name2 = function(a,b,bbw) {
	return a + (b-a) * bbw;
}

//角度
Game.prototype.Radi = function(x,y, xx,yy) {
	return Math.atan2(yy - y,xx - x);
}

//プレイヤーに対する三角比
Game.prototype.PlayerRadis = function(x,y) {
	const r = Math.atan2(Player.y - y,Player.x - x);
	return [Math.cos(r),Math.sin(r),r];
}

//プレイヤーに対する角度
Game.prototype.PlayerRadi = function(x,y) {
	return Math.atan2(Player.y - y,Player.x - x);
}

//角コサイン
Game.prototype.heriosan = function(r) {
	r = r%TwoPI + TwoPI
	return (2-Math.abs((r/1.5707963267948966)%4-2) -1)*-1;
}

//ランダム
Game.prototype.Random = function(r) {
	return ((Math.random()-0.5)*(r<<1));
}

//Nullを探す
Game.prototype.NullFined = function(fats) {
	let i =0;
	while (fats[i]!=null && fats.length >= i) {
		i++;
	}
	return i;
}

//スプライト
//======================================================================================
//慣性移動
Game.prototype.Move = function(fat) {
	fat.x += fat.hx;
	fat.y += fat.hy;
}

//摩擦
Game.prototype.MoveLose = function(fat,bbw) {
	fat.hx *= bbw;
	fat.hy *= bbw;
}

//プレーヤー当たり
Game.prototype.PlayerHit = function(fat) {
	return game.Atari2(Player,fat) && Player.Live && Player.MutekiTimer == 0;
}

//プレーヤー飛ばし
Game.prototype.PlayerBuyon = function(fat,ssbbw) {
	let bbw = game.PlayerHit(fat);
	if (bbw) {	
		const r = game.PlayerRadis(fat.x,fat.y);
		Player.hx = r[0]*30;
		Player.hy = r[1]*30;
		Player.DrawSize -= 0.3;
		if (ssbbw) {
			fat.hx += -r[0]*6;
			fat.hy += -r[1]*6;
		}
			fat.DrawSize -= 0.2;
			fat.PoyoTimer = 1;
	}
	return bbw;
}

//当たり判定（タイマン）
Game.prototype.Atari = function(ax,ay,a,bx,by,b) {
	//return (	(Math.abs(ax-bx)<(a[0]+b[0])) && (Math.abs(ay-by)<(a[1]+b[1]))	);
	return (	(Math.abs(ax-bx)<(a[0]+b[0])) ? (Math.abs(ay-by)<(a[1]+b[1])) : false);
}
//当たり判定2（タイマン）
Game.prototype.Atari2 = function(a,b) {
	//return (	(Math.abs(a.x-b.x)<(a.Size[0]+b.Size[0])) && (Math.abs(a.y-b.y)<(a.Size[1]+b.Size[1]))	);
	return (	(Math.abs(a.x-b.x)<(a.Size[0]+b.Size[0])) ? (Math.abs(a.y-b.y)<(a.Size[1]+b.Size[1])) : false);
	//return (a.x-a.Size[0] < b.x-b.Size[0] ?  (a.y-a.Size[1] < b.y-b.Size[1]) : false);
}

//はらにくぷよぷよ
Game.prototype.PuyoMan = function(fat,maxhp,a) {
	let d = 0;
	if (fat.PoyoTimer>0.9) {
			d = Math.cos(Loop)*a/2;
	} else {
		d = Math.sin(fat.PoyoTimer*30)*fat.PoyoTimer*(fat.Debu/maxhp)*a;
	}
	return Math.abs(d)<0.0001 ? 0 : d;
}

//肉片ばら撒き
Game.prototype.FatBallsFunc = function(x,y,fat) {
	for (let i=0 ; i<fat ; i++) {
		const r = Math.random()*-HalfPI-QuarterPI;
		const s = Math.random()*8+1;
		game.SFXPush(x, y,	Math.cos(r)*s,Math.sin(r)*s,	r,	new game.FatBall());
	}
}

//脂肪飛沫
Game.prototype.FatSlagsFunc = function(x,y,fat) {
	for (let i=0 ; i<fat ; i++) {
		const r = Math.random()*TwoPI;
		const s = Math.random()*5+15;
		game.SFXPush(x, y,	Math.cos(r)*s,Math.sin(r)*s,	r, new game.FatSlag2());
	}
}

//当たり判定
Game.prototype.Ataris = function(fat) {
	let index = null;
	for (let j=0;j<Sprites.length;j++) {
		if (Sprites[j] != null) {
			if (Sprites[j].Size != false) {
				//if (game.Atari(Sprites[j].x, Sprites[j].y, Sprites[j].Size, fat.x, fat.y, fat.Size)) {
				if (game.Atari2(Sprites[j], fat)) {
					//より手前のやつに
					if (index == null) {
						index = j;
					} else if (Sprites[index].x-Sprites[index].Size[0] < Sprites[j].x-Sprites[j].Size[0]) {
						index = j;
					}
				}
			}
		}
	}
	return index;
}

//ダメージの色
Game.prototype.Dame = function(d) {
	return (d ? (Loop2 ? "rgba(255,0,0,0.4)" : "rgba(255,55,0,0.4)") : false);
}
//ダメージの色2
Game.prototype.Dame2 = function(d) {
	return (d ? (Loop2 ? "rgba(255,0,0,1)" : "rgba(255,55,0,1)") : false);
}

//画面外
Game.prototype.ScreenOut = function(x,y) {
	const sa = 100;
	return (x<-SizeX-sa || x>SizeX+sa || y<-SizeY-sa || y>SizeY+sa);
}

//画面外なら消える
Game.prototype.GamenOut = function(fat) {
	if (game.ScreenOut(fat.x, fat.y)) {
		fat.Live = false;
	}
}

//スプライトいらす？
Game.prototype.CallSprite = function(fat, key) {
	if (Sprites[fat] != undefined) {
		if (Sprites[fat].Key == key) {
			return true;
		}
	}
	return false;
}

//汗が出る
Game.prototype.AseFunc = function(x,y) {
	if (Loop%8==0) game.SFXPush(x+game.Random(30),y+game.Random(30), 0,0, Math.random()/2-QuarterPI,	new game.Ase());
}

//汗が出る2
Game.prototype.AseFunc2 = function(x,y,l,ind,key) {
	if (Loop%24==0) game.SFXPush(x,y, 0,0, HalfPI,	new game.Ase2(ind,key,x+game.Random(l),y+game.Random(l)));
}

//肉が出る
Game.prototype.NikuFunc = function(x,y,fat) {
	for (let i=0 ; i<fat ; i++) {
		const r = Math.random()*TwoPI;
		const s = 8+Math.random()*2;
		game.ZikiTamaPush(x, y,	Math.cos(r)*s,Math.sin(r)*s,	0,			new game.NikuNiku());
	}
}
//肉が出る2
Game.prototype.NikusFunc = function(x,y) {
	if (Loop%10==0) game.NikuFunc(x,y,1);
}

//自機脂肪
Game.prototype.PlayerKill = function(type) {
	if (Player.Live) {
		Player.Live = false;
		Player.Fight = false;	
		Player.DeathTimer = 0;
		Player.DeathType = type;
		Player.dx -= 2;
		Player.DrawSize = 0.5;
		game.SFXPush(Player.x, Player.y, 0,0, 0,	new game.Stars());
		Player.Sibas = [];
		game.RankMan(-0.2);
	}
}

//柴犬ゲット
Game.prototype.GetSiba = function() {
	if (Player.Sibas.length<100) {
		if (Player.Sibas.length==0) Player.SibasType = Math.round(Math.random()*1);
		//if (Player.Sibas.length==0) Player.SibasType = 2;
		Player.Sibas.push({x: Player.x, y: Player.y,	gx: Player.x, gy: Player.y});
	}
	game.PlaySE("Get00");		//音
}

//撃っていい?
Game.prototype.LiveShoot = function() {
	return Player.Fight;
}

//座標指定移動？
Game.prototype.GoMove = function(fat,fx,fy,k) {
	fat.x = (fat.x* (k-1) + fx)/k;
	fat.y = (fat.y* (k-1) + fy)/k;
}

//座標指定移動
Game.prototype.GoMove2 = function(fat,fx,fy,k) {
	fat.x = game.Name2(fat.x, fx, k);
	fat.y = game.Name2(fat.y, fy, k);
}

//早回し防止エントリー
Game.prototype.Hayamawasi = function() {
	Mawasi++;
}
