//画像
Game.prototype.LoadImg = function(img) {
	let data = new Image();
	data.src = img;
	return data;
}

var GFXs = {
	Test :		game.LoadImg("GFXs/test.png"),

	Wall0 :		game.LoadImg("GFXs/wall_0.png"),

	Text :		game.LoadImg("GFXs/text.png"),
	Text01 :		game.LoadImg("GFXs/text_01.png"),

	Text0 :		game.LoadImg("GFXs/texts/text_0.png"),
	Text1 :		game.LoadImg("GFXs/texts/text_1.png"),
	Text2 :		game.LoadImg("GFXs/texts/text_2.png"),
	Text3 :		game.LoadImg("GFXs/texts/text_3.png"),
	Text4 :		game.LoadImg("GFXs/texts/text_4.png"),
	Text5 :		game.LoadImg("GFXs/texts/text_5.png"),
	Text6 :		game.LoadImg("GFXs/texts/text_6.png"),
	Text7 :		game.LoadImg("GFXs/texts/text_7.png"),
	Text8 :		game.LoadImg("GFXs/texts/text_8.png"),
	Text9 :		game.LoadImg("GFXs/texts/text_9.png"),

	Text20 :		game.LoadImg("GFXs/texts/text_20.png"),
	Text21 :		game.LoadImg("GFXs/texts/text_21.png"),
	Text22 :		game.LoadImg("GFXs/texts/text_22.png"),
	Text23 :		game.LoadImg("GFXs/texts/text_23.png"),

	Text30 :		game.LoadImg("GFXs/texts/text_30.png"),

	Level01 :		game.LoadImg("GFXs/texts/level_01.png"),
	Level02 :		game.LoadImg("GFXs/texts/level_02.png"),
	Level03 :		game.LoadImg("GFXs/texts/level_03.png"),

	Gui0 :		game.LoadImg("GFXs/gui_0.png"),
	Gui1 :		game.LoadImg("GFXs/gui_1.png"),
	Gui2 :		game.LoadImg("GFXs/gui_2.png"),

	Text10 :		game.LoadImg("GFXs/texts/text_10.png"),
	Text11 :		game.LoadImg("GFXs/texts/text_11.png"),
	Text12 :		game.LoadImg("GFXs/texts/text_12.png"),
	Stage01 :		game.LoadImg("GFXs/texts/stage_01.png"),

	Title0 :		game.LoadImg("GFXs/title_0.png"),
	Title1 :		game.LoadImg("GFXs/title_1.png"),
	Title2 :		game.LoadImg("GFXs/title_2.png"),
	Title3 :		game.LoadImg("GFXs/title_3.png"),
	Title4 :		game.LoadImg("GFXs/title_4.png"),

	Back00 :		game.LoadImg("GFXs/levels/back_00.jpg"),
	Back01 :		game.LoadImg("GFXs/levels/back_01.png"),

	Memori00 :	game.LoadImg("GFXs/memori00.png"),
	Memori01 :	game.LoadImg("GFXs/memori01.png"),

	Player00 :	game.LoadImg("GFXs/player_00.png"),
	Player01 :	game.LoadImg("GFXs/player_01.png"),
	Player10 :	game.LoadImg("GFXs/player_10.png"),
	Player11 :	game.LoadImg("GFXs/player_11.png"),
	Player12 :	game.LoadImg("GFXs/player_12.png"),
	Player20 :	game.LoadImg("GFXs/player_20.png"),
	Player21 :	game.LoadImg("GFXs/player_21.png"),
	Player22 :	game.LoadImg("GFXs/player_22.png"),
	Player23 :	game.LoadImg("GFXs/player_23.png"),

	Player50 :	game.LoadImg("GFXs/player_50.png"),
	Player60 :	game.LoadImg("GFXs/player_60.png"),
	Player61 :	game.LoadImg("GFXs/player_61.png"),
	Player62 :	game.LoadImg("GFXs/player_62.png"),
	Player70 :	game.LoadImg("GFXs/player_70.png"),
	Player71 :	game.LoadImg("GFXs/player_71.png"),

	Tama00 :		game.LoadImg("GFXs/tamas/tama_00.png"),
	Tama01 :		game.LoadImg("GFXs/tamas/tama_01.png"),

	Tama10 :		game.LoadImg("GFXs/tamas/tama_10.png"),
	Tama11 :		game.LoadImg("GFXs/tamas/tama_11.png"),
	Tama12 :		game.LoadImg("GFXs/tamas/tama_12.png"),
	Tama13 :		game.LoadImg("GFXs/tamas/tama_13.png"),
	Tama14 :		game.LoadImg("GFXs/tamas/tama_14.png"),
	Tama15 :		game.LoadImg("GFXs/tamas/tama_15.png"),
	Tama16 :		game.LoadImg("GFXs/tamas/tama_16.png"),
	Tama17 :		game.LoadImg("GFXs/tamas/tama_17.png"),
	Tama18 :		game.LoadImg("GFXs/tamas/tama_18.png"),
	Tama19 :		game.LoadImg("GFXs/tamas/tama_19.png"),

	Tama20 :		game.LoadImg("GFXs/tamas/tama_20.png"),
	Tama21 :		game.LoadImg("GFXs/tamas/tama_21.png"),
	Tama22 :		game.LoadImg("GFXs/tamas/tama_22.png"),
	Tama23 :		game.LoadImg("GFXs/tamas/tama_23.png"),
	Tama24 :		game.LoadImg("GFXs/tamas/tama_24.png"),

	Tama30 :		game.LoadImg("GFXs/tamas/tama_30.png"),
	Tama31 :		game.LoadImg("GFXs/tamas/tama_31.png"),
	Tama32 :		game.LoadImg("GFXs/tamas/tama_32.png"),

	Sfx00 :		game.LoadImg("GFXs/sfxs/sfx_00.png"),
	Sfx01 :		game.LoadImg("GFXs/sfxs/sfx_01.png"),
	Sfx02 :		game.LoadImg("GFXs/sfxs/sfx_02.png"),
	Sfx03 :		game.LoadImg("GFXs/sfxs/sfx_03.png"),
	Sfx04 :		game.LoadImg("GFXs/sfxs/sfx_04.png"),

	Sfx10 :		game.LoadImg("GFXs/sfxs/sfx_10.png"),
	Sfx11 :		game.LoadImg("GFXs/sfxs/sfx_11.png"),
	Sfx12 :		game.LoadImg("GFXs/sfxs/sfx_12.png"),
	Sfx13 :		game.LoadImg("GFXs/sfxs/sfx_13.png"),
	Sfx14 :		game.LoadImg("GFXs/sfxs/sfx_14.png"),
	Sfx15 :		game.LoadImg("GFXs/sfxs/sfx_15.png"),

	Sfx20 :		game.LoadImg("GFXs/sfxs/sfx_20.png"),
	Sfx21 :		game.LoadImg("GFXs/sfxs/sfx_21.png"),
	Sfx22 :		game.LoadImg("GFXs/sfxs/sfx_22.png"),
	Sfx23 :		game.LoadImg("GFXs/sfxs/sfx_23.png"),
	Sfx24 :		game.LoadImg("GFXs/sfxs/sfx_24.png"),

	Sfx30 :		game.LoadImg("GFXs/sfxs/sfx_30.png"),
	Sfx31 :		game.LoadImg("GFXs/sfxs/sfx_31.png"),
	Sfx32 :		game.LoadImg("GFXs/sfxs/sfx_32.png"),
	Sfx33 :		game.LoadImg("GFXs/sfxs/sfx_33.png"),
	Sfx34 :		game.LoadImg("GFXs/sfxs/sfx_34.png"),

	Sfx40 :		game.LoadImg("GFXs/sfxs/sfx_40.png"),
	Sfx41 :		game.LoadImg("GFXs/sfxs/sfx_41.png"),
	Sfx42 :		game.LoadImg("GFXs/sfxs/sfx_42.png"),
	Sfx43 :		game.LoadImg("GFXs/sfxs/sfx_43.png"),

	Sfx50 :		game.LoadImg("GFXs/sfxs/sfx_50.png"),
	Sfx51 :		game.LoadImg("GFXs/sfxs/sfx_51.png"),
	Sfx52 :		game.LoadImg("GFXs/sfxs/sfx_52.png"),

	Sfx60 :		game.LoadImg("GFXs/sfxs/sfx_60.png"),

	BG00 :		game.LoadImg("GFXs/levels/bg_00.jpg"),
	BG01 :		game.LoadImg("GFXs/levels/bg_01.png"),
	BG02 :		game.LoadImg("GFXs/levels/bg_02.png"),
	BG03 :		game.LoadImg("GFXs/levels/bg_03.png"),

	BG10 :		game.LoadImg("GFXs/levels/bg_10.jpg"),
	BG11 :		game.LoadImg("GFXs/levels/bg_11.png"),
	BG12 :		game.LoadImg("GFXs/levels/bg_12.png"),
	BG13 :		game.LoadImg("GFXs/levels/bg_13.png"),
	BG14 :		game.LoadImg("GFXs/levels/bg_14.png"),
	BG15 :		game.LoadImg("GFXs/levels/bg_15.png"),
	BG16 :		game.LoadImg("GFXs/levels/bg_16.png"),

	BG20 :		game.LoadImg("GFXs/levels/bg_20.png"),

	BG30 :		game.LoadImg("GFXs/levels/bg_30.png"),
	BG31 :		game.LoadImg("GFXs/levels/bg_31.png"),
	BG32 :		game.LoadImg("GFXs/levels/bg_32.png"),
	BG33 :		game.LoadImg("GFXs/levels/bg_33.png"),
	BG34 :		game.LoadImg("GFXs/levels/bg_34.png"),
	BG35 :		game.LoadImg("GFXs/levels/bg_35.png"),
	BG36 :		game.LoadImg("GFXs/levels/bg_36.jpg"),
	BG37 :		game.LoadImg("GFXs/levels/bg_37.png"),

	Teki00 :		game.LoadImg("GFXs/tekis/teki_00.png"),
	Teki01 :		game.LoadImg("GFXs/tekis/teki_01.png"),
	Teki02 :		game.LoadImg("GFXs/tekis/teki_02.png"),
	Teki03 :		game.LoadImg("GFXs/tekis/teki_03.png"),
	Teki04 :		game.LoadImg("GFXs/tekis/teki_04.png"),

	Teki10 :		game.LoadImg("GFXs/tekis/teki_10.png"),
	Teki11 :		game.LoadImg("GFXs/tekis/teki_11.png"),
	Teki12 :		game.LoadImg("GFXs/tekis/teki_12.png"),

	Teki20 :		game.LoadImg("GFXs/tekis/teki_20.png"),
	Teki21 :		game.LoadImg("GFXs/tekis/teki_21.png"),
	Teki22 :		game.LoadImg("GFXs/tekis/teki_22.png"),
	Teki23 :		game.LoadImg("GFXs/tekis/teki_23.png"),
	Teki24 :		game.LoadImg("GFXs/tekis/teki_24.png"),

	Teki30 :		game.LoadImg("GFXs/tekis/teki_30.png"),
	Teki31 :		game.LoadImg("GFXs/tekis/teki_31.png"),
	Teki32 :		game.LoadImg("GFXs/tekis/teki_32.png"),
	Teki33 :		game.LoadImg("GFXs/tekis/teki_33.png"),
	Teki34 :		game.LoadImg("GFXs/tekis/teki_34.png"),

	Teki40 :		game.LoadImg("GFXs/tekis/teki_40.png"),
	Teki41 :		game.LoadImg("GFXs/tekis/teki_41.png"),
	Teki42 :		game.LoadImg("GFXs/tekis/teki_42.png"),
	Teki43 :		game.LoadImg("GFXs/tekis/teki_43.png"),
	Teki44 :		game.LoadImg("GFXs/tekis/teki_44.png"),

	Teki50 :		game.LoadImg("GFXs/tekis/teki_50.png"),
	Teki51 :		game.LoadImg("GFXs/tekis/teki_51.png"),

	Teki60 :		game.LoadImg("GFXs/tekis/teki_60.png"),
	Teki61 :		game.LoadImg("GFXs/tekis/teki_61.png"),
	Teki62 :		game.LoadImg("GFXs/tekis/teki_62.png"),
	Teki63 :		game.LoadImg("GFXs/tekis/teki_63.png"),
	Teki64 :		game.LoadImg("GFXs/tekis/teki_64.png"),

	Boss10 :		game.LoadImg("GFXs/bosses/boss_10.png"),
	Boss11 :		game.LoadImg("GFXs/bosses/boss_11.png"),
	Boss12 :		game.LoadImg("GFXs/bosses/boss_12.png"),
	Boss13 :		game.LoadImg("GFXs/bosses/boss_13.png"),
	Boss14 :		game.LoadImg("GFXs/bosses/boss_14.png"),
	Boss15 :		game.LoadImg("GFXs/bosses/boss_15.png"),
	Boss16 :		game.LoadImg("GFXs/bosses/boss_16.png"),
	Boss17 :		game.LoadImg("GFXs/bosses/boss_17.png"),
	Boss18 :		game.LoadImg("GFXs/bosses/boss_18.png"),

	Boss200 :		game.LoadImg("GFXs/bosses/boss_200.png"),
	Boss201 :		game.LoadImg("GFXs/bosses/boss_201.png"),
	Boss202 :		game.LoadImg("GFXs/bosses/boss_202.png"),
	Boss203 :		game.LoadImg("GFXs/bosses/boss_203.png"),
	Boss204 :		game.LoadImg("GFXs/bosses/boss_204.png"),
	Boss205 :		game.LoadImg("GFXs/bosses/boss_205.png"),
	Boss206 :		game.LoadImg("GFXs/bosses/boss_206.png"),
	Boss207 :		game.LoadImg("GFXs/bosses/boss_207.png"),

	Boss250 :		game.LoadImg("GFXs/bosses/boss_250.png"),
	Boss251 :		game.LoadImg("GFXs/bosses/boss_251.png"),
	Boss252 :		game.LoadImg("GFXs/bosses/boss_252.png"),
	Boss253 :		game.LoadImg("GFXs/bosses/boss_253.png"),
	Boss254 :		game.LoadImg("GFXs/bosses/boss_254.png"),
	Boss255 :		game.LoadImg("GFXs/bosses/boss_255.png"),

	Boss300 :		game.LoadImg("GFXs/bosses/boss_300.png"),
	Boss301 :		game.LoadImg("GFXs/bosses/boss_301.png"),
	Boss320 :		game.LoadImg("GFXs/bosses/boss_320.png"),
	Boss321 :		game.LoadImg("GFXs/bosses/boss_321.png"),
	Boss322 :		game.LoadImg("GFXs/bosses/boss_322.png"),
	Boss330 :		game.LoadImg("GFXs/bosses/boss_330.png"),
	Boss331 :		game.LoadImg("GFXs/bosses/boss_331.png"),
	Boss340 :		game.LoadImg("GFXs/bosses/boss_340.png"),
	Boss341 :		game.LoadImg("GFXs/bosses/boss_341.png"),
	Boss342 :		game.LoadImg("GFXs/bosses/boss_342.png"),
	Boss343 :		game.LoadImg("GFXs/bosses/boss_343.png"),
}


//音
var SEVolume  = 0.3;	//効果音音量
var SoundFlags = [];	//1フレームに複数鳴るの防止
Game.prototype.LoadSound = function(img) {
	let data = new Audio();
	data.src = img;
	return data;
}
var SOUNDs = {
	Shoot00:		game.LoadSound("SEs/shot.wav"),							//自機ショット		ぱf
	Shoot01:		game.LoadSound("SEs/se_maoudamashii_battle_gun02.mp3"),	//通常ショット		ﾊﾟｷｭｩ
	Shoot02:		game.LoadSound("SEs/se_maoudamashii_battle07.mp3"),		//ショット			ﾄﾞｳ
	Shoot03:		game.LoadSound("SEs/se_maoudamashii_battle10.mp3"),		//斧ショット		キｨ～ン

	Hit00:		game.LoadSound("SEs/hit.wav"),								//自機弾ヒット		ﾎﾞﾝ

	Boom00:		game.LoadSound("SEs/se_maoudamashii_battle15.mp3"),			//ザコ破裂			パン
	Boom01:		game.LoadSound("SEs/se_maoudamashii_battle03.mp3"),			//					sタﾝ

	Get00:		game.LoadSound("SEs/se_maoudamashii_voice_dog02.mp3"),		//ワンコビット取得	ﾜﾝﾜﾝ
	SE00:		game.LoadSound("SEs/se_maoudamashii_retro03.mp3"),			

	FatA00:		game.LoadSound("SEs/gainA_00.wav"),							//肥満化			ﾑ ﾖｯ
	FatA01:		game.LoadSound("SEs/gainA_01.wav"),
	FatA02:		game.LoadSound("SEs/gainA_02.wav"),

	Densya00:	game.LoadSound("SEs/tatan.wav"),							//3面電車			ﾀﾀﾝﾀﾀﾝﾀﾀﾝ…

	Meka00:	game.LoadSound("SEs/se_maoudamashii_se_door02.mp3"),				//2ボスの足音		ﾂﾄﾞー
}


//==============================================================================================
// stats.js r9 - http://github.com/mrdoob/stats.js
var Stats=function(){var h,a,r=0,s=0,i=Date.now(),u=i,t=i,l=0,n=1E3,o=0,e,j,f,b=[[16,16,48],[0,255,255]],m=0,p=1E3,q=0,d,k,g,c=[[16,48,16],[0,255,0]];h=document.createElement("div");h.style.cursor="pointer";h.style.width="80px";h.style.opacity="0.9";h.style.zIndex="10001";h.addEventListener("mousedown",function(a){a.preventDefault();r=(r+1)%2;0==r?(e.style.display="block",d.style.display="none"):(e.style.display="none",d.style.display="block")},!1);e=document.createElement("div");e.style.textAlign=
"left";e.style.lineHeight="1.2em";e.style.backgroundColor="rgb("+Math.floor(b[0][0]/2)+","+Math.floor(b[0][1]/2)+","+Math.floor(b[0][2]/2)+")";e.style.padding="0 0 3px 3px";h.appendChild(e);j=document.createElement("div");j.style.fontFamily="Helvetica, Arial, sans-serif";j.style.fontSize="9px";j.style.color="rgb("+b[1][0]+","+b[1][1]+","+b[1][2]+")";j.style.fontWeight="bold";j.innerHTML="FPS";e.appendChild(j);f=document.createElement("div");f.style.position="relative";f.style.width="74px";f.style.height=
"30px";f.style.backgroundColor="rgb("+b[1][0]+","+b[1][1]+","+b[1][2]+")";for(e.appendChild(f);74>f.children.length;)a=document.createElement("span"),a.style.width="1px",a.style.height="30px",a.style.cssFloat="left",a.style.backgroundColor="rgb("+b[0][0]+","+b[0][1]+","+b[0][2]+")",f.appendChild(a);d=document.createElement("div");d.style.textAlign="left";d.style.lineHeight="1.2em";d.style.backgroundColor="rgb("+Math.floor(c[0][0]/2)+","+Math.floor(c[0][1]/2)+","+Math.floor(c[0][2]/2)+")";d.style.padding=
"0 0 3px 3px";d.style.display="none";h.appendChild(d);k=document.createElement("div");k.style.fontFamily="Helvetica, Arial, sans-serif";k.style.fontSize="9px";k.style.color="rgb("+c[1][0]+","+c[1][1]+","+c[1][2]+")";k.style.fontWeight="bold";k.innerHTML="MS";d.appendChild(k);g=document.createElement("div");g.style.position="relative";g.style.width="74px";g.style.height="30px";g.style.backgroundColor="rgb("+c[1][0]+","+c[1][1]+","+c[1][2]+")";for(d.appendChild(g);74>g.children.length;)a=document.createElement("span"),
a.style.width="1px",a.style.height=30*Math.random()+"px",a.style.cssFloat="left",a.style.backgroundColor="rgb("+c[0][0]+","+c[0][1]+","+c[0][2]+")",g.appendChild(a);return{getDomElement:function(){return h},getFps:function(){return l},getFpsMin:function(){return n},getFpsMax:function(){return o},getMs:function(){return m},getMsMin:function(){return p},getMsMax:function(){return q},update:function(){i=Date.now();m=i-u;p=Math.min(p,m);q=Math.max(q,m);k.textContent=m+" MS ("+p+"-"+q+")";var a=Math.min(30,
30-30*(m/200));g.appendChild(g.firstChild).style.height=a+"px";u=i;s++;if(i>t+1E3)l=Math.round(1E3*s/(i-t)),n=Math.min(n,l),o=Math.max(o,l),j.textContent=l+" FPS ("+n+"-"+o+")",a=Math.min(30,30-30*(l/100)),f.appendChild(f.firstChild).style.height=a+"px",t=i,s=0}}};
var stats = new Stats();
//==============================================================================================
