//プレーヤーの処理
Game.prototype.player = function() {
	this.x = -200,		this.y = 0,
	this.hx = 0,		this.hy = 0,
	this.dx = 0,		this.dy = 0,
	this.MoveTimer = 0,
	this.ShootTimer = 0,
	this.DrawSize	 = 0;
	this.Size = [40,20];

	this.Type = 0;

	this.Fight = true;
	this.Live = true;
	this.DeathTimer = 0;
	this.DeathType = 0;
	this.MutekiTimer = 0;

	this.Sibas = [];
	this.SibasType = 0;

	this.MoveXs = [-200],	this.MoveYs = [0];
}

Player = new game.player();		//プレーヤー

Game.prototype.player.prototype.Func = function() {

	let gfxs = [];
	//グラ
	if (this.Type == 0) {
		gfxs = [
				"Player00",	//通常
				"Player10",	//切断（前）
				"Player11",	//奥
				"Player12",	//イタイ…
				"Player20",	//でぶでぶ
				"Player21",	//でぶでぶ２
			]
	} else {
		gfxs = [
				"Player50",	//通常
				"Player60",	//切断（前）
				"Player61",	//奥
				"Player62",	//イタイ…
				"Player70",	//でぶでぶ
				"Player71",	//でぶでぶ２
			]
	}

	game.Move(this);			//慣性移動
	game.MoveLose(this,0.9);		//摩擦

	const DrowPls = 0.1;
	if (this.Live) {
		//入力
		const UP =	game.UP(true);
		const DW =	game.DOWN(true);
		const RI =	game.RIGHT(true);
		const LE =	game.LEFT(true);
		const SHOOT =	game.SHOOT(true);

		//移動
		this.dx = 0;
		this.dy = 0;
		let move = false;
		const speed = SHOOT ? 10 : 12;
		if (LE) {
			this.x	-= speed;
			this.dx	= -speed;
			move	= true;
		} else if (RI) {
			this.x	+= speed;
			this.dx	= speed;
			move	= true;
		}
		if (UP) {
			this.y	-= speed;
			this.dy	= -speed;
			move	= true;
		} else if (DW) {
			this.y	+= speed;
			this.dy	= speed;
			move	= true;

		}

		//game.Move(Player);			//慣性移動
		//game.MoveLose(Player,0.9);		//摩擦

		//移動制限
		const sa = 80;
		this.x = Math.min(SizeX-sa,Math.max(-SizeX+sa,this.x));
		this.y = Math.min(SizeY-sa,Math.max(-SizeY+sa,this.y));

		//バタバタ
		if (move) {
			this.MoveTimer++;
		} else {
			this.MoveTimer = 0;
		}

		//くらえ脂肪弾
		if (SHOOT && Player.Live) {
			//if (this.ShootTimer>=4) {

				if (this.ShootTimer%4==0) {
				//this.x -= 4;
				this.DrawSize -= 0.05;
				game.PlaySE("Shoot00");

				//game.SFXPush(this.x+100, this.y, 0,0, 0,	new game.ShootSibuki());
				if (this.Type == 0) {
					game.ZikiTamaPush(this.x+100, this.y+25,	50,0,	false,	new game.ZikiFatShoot(7, 1.1));
					game.ZikiTamaPush(this.x+100, this.y-25,	50,0,	false,	new game.ZikiFatShoot(7, 1.1));

					/*game.ZikiTamaPush(this.x+100, this.y+25,	50,0,	false,	new game.ZikiFatShoot(3));
					game.ZikiTamaPush(this.x+100, this.y-25,	50,0,	false,	new game.ZikiFatShoot(4));
					game.ZikiTamaPush(this.x+80, this.y+55,	50,0,	false,	new game.ZikiFatShoot(4));
					game.ZikiTamaPush(this.x+80, this.y-55,	50,0,	false,	new game.ZikiFatShoot(3));*/
				} else {
					const r = 0.10;
					game.ZikiTamaPush(this.x+100, this.y,		50,0,					false,	new game.ZikiFatShoot(5, 0.8));
					game.ZikiTamaPush(this.x+100, this.y+45,	Math.cos(r)*50,Math.sin(r)*50,		r,	new game.ZikiFatShoot(6, 0.8));
					game.ZikiTamaPush(this.x+100, this.y-45,	Math.cos(-r)*50,Math.sin(-r)*50,		-r,	new game.ZikiFatShoot(5, 0.8));
				}

				//game.ZikiTamaPush(this.x+100, this.y+Math.cos(this.ShootTimer/12)*45,	50,0,	false,	new game.ZikiFatShoot(10));
				//game.ZikiTamaPush(this.x+100, this.y-Math.cos(this.ShootTimer/12)*45,	50,0,	false,	new game.ZikiFatShoot(10));

				//game.TamaPush("test",this.x+100, this.y, 50,0, 0, 0, null);
				/*const radi = Math.sin(Player.ShootTimer/6)/20;
				game.TamaPush("test",this.x+100,this.y, Math.cos(radi)*50,Math.sin(radi)*50, radi, 0, null);
				Player.DrowSize = 0.1;*/

				/*const radii = Math.sin(Math.random()-0.5)/2;
				const speed = Math.random()*5+10;
				game.SFXPush("Fat",this.x,this.y, -Math.cos(radii)*speed,Math.sin(radii)*speed, radi, 0, null);*/
				}
			//}
			this.ShootTimer++;
		} else {
			/*if (this.ShootTimer != 0 && this.ShootTimer<4) {
				game.ZikiTamaPush(this.x+100, this.y,	50,0,	false,	new game.ZikiFatShoot(10));
			}*/
			this.ShootTimer = 0;
		}

		//描画
		const img =0;

		if (this.MutekiTimer%2==0) game.DrawKage(ctxA,GFXs[gfxs[img]],this.x,this.y-10,		this.DrawSize-DrowPls,this.DrawSize-DrowPls,		false,false,	false);

		//軌道
		if (Math.abs(Player.MoveXs[0] - Player.x)>1 || Math.abs(Player.MoveYs[0] - Player.y)>1) {
			//game.DrawKage(ctxA,GFXs["Test"],this.x,this.y-100,		1,1,		false,false,	false);
			Player.MoveXs.unshift(Player.x);
			Player.MoveYs.unshift(Player.y);
			if (Player.MoveXs.length>1000) {
				Player.MoveXs.pop();
				Player.MoveYs.pop();
			}
		}

		this.MutekiTimer = Math.max(0,this.MutekiTimer-1);

	//死んでいる
	} else {
		const dt = this.DeathTimer;
		if (dt > 150) {
			if (Zanki == 0) {
				game.GameOvarFunc();
			} else {
				Zanki--;
				this.Fight = true;
				this.Live = true;
				this.x = -200;
				this.y = 0;
				Player.MoveXs = [this.x];
				Player.MoveYs = [this.y];
				this.MutekiTimer = 200;
			}
		} else {
			const b = dt<50 || (Loop2 && dt<100);
			switch (this.DeathType) {
				//肥満死
				case 0 :
					if (dt<80) {
						game.DrawKage(ctxA,GFXs[dt%10<5 ? gfxs[4] : gfxs[5]],this.x,this.y,
							this.DrawSize-DrowPls,this.DrawSize-DrowPls,		false,false,	false);

						this.dy+=0.1;
						game.AseFunc(this.x+60, this.y-150);
						game.AseFunc(this.x+60, this.y-150);

					} else if (dt==80) {
						game.SFXPush(this.x, this.y, 0,0, 0,	new game.Stars());
						game.FatBallsFunc(this.x,this.y,42);
						game.FatSlagsFunc(this.x,this.y,30);
					}
					break;
				//切断死
				case 1:
					if (b) {
						game.DrawKage(ctxA,GFXs[gfxs[1]],this.x-dt/4,this.y-dt/8,
							1-DrowPls,1-DrowPls,		false,false,	false);
						game.DrawKage(ctxB,GFXs[gfxs[2]],this.x+dt/4,this.y+dt/8,
							1-DrowPls,1-DrowPls,		false,false,	false);
						game.DrawKage(ctxB,GFXs[Loop4 ? "Sfx50" : "Sfx51"],this.x,this.y,
							2,(70-dt)/70,		false,false,	false);
					}
					if (dt<50) game.SFXPush(this.x, this.y,	game.Random(20)+30,game.Random(30),	false,	new game.Ti(10));
					break;
				//超痛い
				case 2:
					if (b) {
						game.DrawKage(ctxA,GFXs[gfxs[3]],this.x,this.y,
							1-DrowPls,1-DrowPls,		false,false,	false);
					}
					if (dt<50) game.AseFunc(this.x+60, this.y-50);
					break;
			}
			this.DeathTimer++;

			this.x += this.dx;
			this.y += this.dy;
			this.dx *= 0.95;
			this.dy *= 0.95;

			//移動制限
			const sa = 80;
			this.x = Math.min(SizeX-sa,Math.max(-SizeX+sa,this.x));
			this.y = Math.min(SizeY-sa,Math.max(-SizeY+sa,this.y));
		}
	}

	//共通
	this.DrawSize = ((this.DrawSize - 1) * 0.80) + 1;
	if (this.DrawSize > 0.99) this.DrowSize = 1;

	//柴
	if (game.SHOOTSUB(false) && Player.Sibas.length != 0) Player.SibasType = (Player.SibasType+1)%4;	//フォーメーション
	for (let i=0 ; i<Player.Sibas.length ; i++) {
		//let gx = Player.x,	gy=Player.y;
		let ctx = ctxB,	col = false;
		const off = i==0 ? 1 : -1;
		switch (Player.SibasType) {
			//上下
			case 0 :
				Player.Sibas[i].gx = Player.x;
				Player.Sibas[i].gy = Player.y + (this.MoveTimer<1 ? 200 : 130)*-off;
				break;

			//回し
			case 1 :
				if (this.Type == 0) {
					const x = Math.sin(Loop/12)*off;
					Player.Sibas[i].gx = Player.x + 150 + x*20;
					Player.Sibas[i].gy = Player.y - Math.cos(Loop/12)*80*off;
					if (x<0) {
						ctx = ctxA;
					} else {
						col = "rgba(88,88,88," + x/3 + ")";
					}
				} else {
					const r = Loop / 12;
					Player.Sibas[i].gx = Player.x + Math.cos(r) * off * 120;
					Player.Sibas[i].gy = Player.y + Math.sin(r) * off * 60;
				}
				break;
			//グラ
			case 2 :
				const ind = Math.min(Player.MoveXs.length-1, i*15+15);
				Player.Sibas[i].gx = Player.MoveXs[ind];
				Player.Sibas[i].gy = Player.MoveYs[ind];
				break;
			//設置
			case 3 :
				break;
		}
		//位置合わせ
		Player.Sibas[i].x = ((Player.Sibas[i].x-Player.Sibas[i].gx)*0.85)+Player.Sibas[i].gx;
		Player.Sibas[i].y = ((Player.Sibas[i].y-Player.Sibas[i].gy)*0.85)+Player.Sibas[i].gy;
		//描画
		game.DrawKage(ctx,GFXs[Loop8 ? "Player22" : "Player23"],	Player.Sibas[i].x,Player.Sibas[i].y,	0.8,0.8,	col,false,	false);
		//発射
		if (Player.ShootTimer%6==1)	{
			game.ZikiTamaPush(Player.Sibas[i].x+50,Player.Sibas[i].y,	50,0,	false,	new game.ZikiFatShoot(4, 0.8));
		}
	}

	//カメラ
	if (this.y-ScreenY < -70) {
		ScreenY = Math.max(-SizeY+HeightHalf,ScreenY-5);
	} else if (this.y-ScreenY > 70) {
		ScreenY = Math.min(SizeY-HeightHalf,ScreenY+5);
	}
}